import java.io.*;
import java.awt.*;
import java.net.*;
import java.applet.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
public class OpenLevelMpoint3D extends JApplet implements Runnable,ActionListener,KeyListener{
    JLabel la;
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    Thread t;
    JButton b;
    boolean startb=false;
    static JApplet app;
    static OpenLevelMpoint3D app2;
    JPanel p1;
    Mpoint3D game;
    private static final long serialVersionUID = 8992863981608356240L;
    public void init(){
        la=new JLabel("Mpoint3D");
        add(la);
        la.setBounds(10,10,200,27);
        app=this;
        app2=this;
        setSize(400,480);
        setLayout(null);
        p1=new JPanel();
        p1.setLayout(null);
        add(p1);
        p1.setBounds(0,40,400,440);
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        b=new JButton("open");
        p1.add(spl);
        p1.add(b);
        spl.setBounds(10,40,380,300);
        b.setBounds(10,350,380,27);
        readLevelList();
        b.addActionListener(this);
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        t=new Thread(this);
        t.start();
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public void run(){
        while(true){
            try{
                Thread.sleep(100);
                int ind=l.getSelectedIndex();
                if(startb&&ind!=-1&&ind<lcontent.size()){
                    startb=false;
                    String levstring=lcontent.elementAt(ind);
                    la.setText("Mpoint3D");
                    game=new Mpoint3D(this,levstring);
                    p1.setVisible(false);
                    add(game);
                    game.setBounds(0,0,400,440);
                }
            }
            catch(Exception e){
            }
        }
    }
    public void actionPerformed(ActionEvent evt){
            if(evt.getSource()==b){
                startb=true;
            }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
        if(game!=null){
            game.process(e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void readLevelList(){
        try{
            InputStream is=OpenLevelMpoint3D.getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            String news="";
            while((news=dis.readLine())!=null){
                lcontent.addElement(news);
            }
            is.close();
            l.setListData(lcontent);
        }
        catch(Exception e){};
    }
}

class Mpoint3D extends JPanel implements Runnable{
    Thread t;
    int xpos=0;
    int ypos=0;
    int xdrift=0;
    int ydrift=7;
    String name;
    int[][]screen;
    Group[][]groupscreen;
    Group[][]groupscreenb;
    Group player;
    int width=0;
    int height=0;
    int lifes=3;
    int points=0;
    int treasures=0;
    int xstart=0;
    int ystart=0;
    boolean wall=true;
    boolean inverse=false;
    boolean moveplayer=true;
    double alpha=Math.PI/2;
    double beta=Math.PI/4;
    Vektor camerapos;
    Vektor cameraposplus;
    Bomb[]bombs=new Bomb[100];
    EngineMpoint3D eng;
    OpenLevelMpoint3D ol;
    boolean endfirst=true;
    boolean running=true;
    Color pcolor;
    Color pcolor2;
    int turbo=0;
    int drive=0;
    int direction=0;
    int turbob=0;
    int driveb=0;
    int directionb=0;
    int phase=4;
    boolean all=false;
    int keycode=0;
    int winstatus=0;
    private static final long serialVersionUID = -3813852377194924967L;
    public Mpoint3D(OpenLevelMpoint3D ol,String name){
//        super("Astro Solutions Mpoint3D");
//        resize(400,440);
        setLayout(null);
        this.ol=ol;
        pcolor=new Color(255,255,0);
        pcolor2=new Color(255,0,0);
        eng=new EngineMpoint3D();
        eng.setStatus("");
        add(eng);
        eng.setBounds(0,40,400,400);
        setVisible(true);
        this.name=name;
        screen=new int[30][18];
        groupscreen=new Group[30][18];
        groupscreenb=new Group[30][18];
        player=ObjectGenerator.getKugel();
        loadScreen();
        build();
        t=new Thread(this);
        t.start();
    }
    public void setWallOn(){
        wall=true;
    }
    public void setWallOff(){
        wall=false;
    }
    public void loadScreen(){
        try{
            InputStream is=OpenLevelMpoint3D.getInputStream(name);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=is.read();
//System.out.println("i: "+i+" j: "+j+" screen: "+screen[i][j]);
                    if(screen[i][j]==4){
                        treasures++;
                    }
                    if(screen[i][j]==3){
                        xpos=i*50+25;
                        ypos=j*50+25;
                        xstart=xpos;
                        ystart=ypos;
                        camerapos=new Vektor(xpos,ypos,300);
                        cameraposplus=new Vektor(-Math.cos(alpha)*300,-Math.sin(alpha)*300,0);
                        player.transform(xpos,ypos,0);
                        eng.add(player);
                        screen[i][j]=0;
                    }
                }
            }
        }
        catch(Exception e){
        }
    }
    public void run(){
        int gc=0;
        while(running){
//            try{
//System.out.println("xxx"+Runtime.getRuntime().freeMemory());
                if(keycode!=0){
                    process(keycode);
                }
                keycode=0;
                step();
//System.out.println("yyy");
                if(gc>=100){
                    gc=0;
                    System.gc();
                }
                gc=gc+1;
//System.out.println("yyy");
                cameraposplus.x=Math.cos(alpha)*300;
                cameraposplus.y=Math.sin(alpha)*300;
                double xtrans=camerapos.x+cameraposplus.x;
                double ytrans=camerapos.y+cameraposplus.y;
                double ztrans=camerapos.z+cameraposplus.z;
                double alphab=alpha;
                double betab=beta;
                setWallOn();
//System.out.println("transform");
                eng.transform(-xtrans,-ytrans,-ztrans);
//System.out.println("xtrans: "+xtrans);
//System.out.println("ytrans: "+ytrans);
//System.out.println("ztrans: "+ztrans);
//System.out.println("alphab: "+alphab);
//System.out.println("betab: "+betab);
                alphab=alphab+Math.PI;
                if(alphab>2*Math.PI){
                    alphab=alphab-2*Math.PI;
                }
                eng.rotLeft(-alphab);
                eng.rotUp(betab);
//System.out.println("gs: "+groupscreen[0][0].start.start.x);
                eng.setOn();
                eng.move();
                eng.repaint();
try{
                Thread.sleep(80);
}
catch(Exception e){
}
                eng.setOff();
                eng.rotUp(-betab);
                eng.rotLeft(alphab);
                eng.transform(xtrans,ytrans,ztrans);
                setWallOff();
//            }
//            catch(Exception e){
//                System.out.println("e: "+e);
//                try{
//                    Thread.sleep(10000);
//                }
//                catch(Exception eb){
//                };
//            }
        }
    }
    public static void main(String[]args){
//        new Dynamite3D("TEST.LEV");
        new OpenLevelMpoint3D();
    }
    public void process(KeyEvent evt){
        keycode=evt.getKeyCode();
    }
    public void process(int key){
            if(key==27||key==KeyEvent.VK_ESCAPE){
                setVisible(false);
                OpenLevelMpoint3D.app2.p1.setVisible(true);
                running=false;
            }
            if(key==KeyEvent.VK_DOWN){
                if(moveplayer){
//System.out.println("a");
                    keyPressed(-4);
                }
                else{
//System.out.println("b");
                    if(!inverse){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else{
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(key==KeyEvent.VK_UP){
                if(moveplayer){
                    keyPressed(-3);
                }
                else{
                    if(inverse){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else{
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(key==KeyEvent.VK_RIGHT){
                if(moveplayer){
                   if(!all){
                       keyPressed(-1);
                   }
                }
                else{
                    alpha=alpha-Math.PI/90;
                    if(alpha<0){
                        alpha=alpha+2*Math.PI;
                    }
                }
            }
            if(key==KeyEvent.VK_LEFT){
                if(moveplayer){
                    if(!all){
                        keyPressed(-2);
                    }
                }
                else{
                    alpha=alpha+Math.PI/90;
                    if(alpha>2*Math.PI){
                        alpha=alpha-2*Math.PI;
                    }
                }
            }
            if(key==KeyEvent.VK_DELETE){
                if(moveplayer){
                    moveplayer=false;
                }
                else{
                    moveplayer=true;
                }
            }
            if(key==KeyEvent.VK_ENTER){
                if(moveplayer){
//                    keyPressed(-5);
                }
            }
    }
    public void keyPressed(int keycode){
        if(keycode==-1){
            xdrift=xdrift+1;
            if(xdrift>10){
                xdrift=10;
            }
        }
        if(keycode==-2){
            xdrift=xdrift-1;
            if(xdrift<-10){
                xdrift=-10;
            }
        }
    }
    public void keyPressedb(int keycode){
        if(keycode==-3){
            double axpos=xpos;
            if(xpos==0){
                xpos=xpos-50;
            }
            if(xpos-50>=0&&screen[(xpos-50)/50][ypos/50]!=1&&screen[(xpos-50)/50][ypos/50]!=2){
                xpos=xpos-50;
            }
            camerapos.x=xpos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(xpos-axpos,0,0);
        }
        if(keycode==-4){
            double axpos=xpos;
            if(xpos==1450){
                xpos=xpos+50;
            }
            if(xpos+50<1500&&screen[(xpos+50)/50][ypos/50]!=1&&screen[(xpos+50)/50][ypos/50]!=2){
                xpos=xpos+50;
            }
            camerapos.x=xpos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(xpos-axpos,0,0);
        }
        if(keycode==-2){
            double aypos=ypos;
            if(ypos==850){
                ypos=ypos+50;
            }
            if(ypos+50<900&&screen[xpos/50][(ypos+50)/50]!=1&&screen[xpos/50][(ypos+50)/50]!=2){
                ypos=ypos+50;
            }
            camerapos.y=ypos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(0,ypos-aypos,0);
        }
        if(keycode==-1){
            double aypos=ypos;
            if(ypos==0){
                ypos=ypos-50;
            }
            if(ypos-50>=0&&screen[xpos/50][(ypos-50)/50]!=1&&screen[xpos/50][(ypos-50)/50]!=2){
                ypos=ypos-50;
            }
            camerapos.y=ypos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(0,ypos-aypos,0);
        }
        if(keycode==-5){
//            newbomb(xpos/50,ypos/50,true);
        }
        if(keycode==-8){
//            Loader mov=new Loader(m,"game stopped");
//            Display d=Display.getDisplay(m);
//            d.setCurrent((Displayable)mov);
        }
    }
    public void build(){
        for(int i=0;i<32;i++){
            Group rand=ObjectGenerator.getHardStone();
            rand.transform(i*50-50,-50,0);
            eng.add(rand);
            Group randx=ObjectGenerator.getBoden();
            randx.transform(i*50-50,-50,0);
            eng.add(randx);
            Group rand2=ObjectGenerator.getHardStone();
            rand2.transform(i*50-50,900,0);
            eng.add(rand2);
            Group randx2=ObjectGenerator.getBoden();
            randx2.transform(i*50-50,900,0);
            eng.add(randx2);
        }
        for(int i=0;i<18;i++){
            Group rand=ObjectGenerator.getHardStone();
            rand.transform(-50,i*50,0);
            eng.add(rand);
            Group randx=ObjectGenerator.getBoden();
            randx.transform(-50,i*50,0);
            eng.add(randx);
            Group rand2=ObjectGenerator.getHardStone();
            rand2.transform(1500,i*50,0);
            eng.add(rand2);
            Group randx2=ObjectGenerator.getBoden();
            randx2.transform(1500,i*50,0);
            eng.add(randx2);
        }
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
                int x=i;
                int y=j;
                if(x>=0&&y>=0&&x<30&&y<18){
//System.out.println("xp:"+xp+"i:"+i);
                    if(screen[x][y]==0){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==1){
                        groupscreen[x][y]=ObjectGenerator.getPoint();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==2){
                        groupscreen[x][y]=ObjectGenerator.getHardStone();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==4){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getSoftStone();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==5){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getPirat();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==6){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,-20);
                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getLoch();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==7){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getSchleuder();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==8){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,-20);
                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getAll();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                }
            }
        }
    }
    public void step(){
        xpos=xpos+xdrift;
        ypos=ypos+ydrift;
        player.transform(xdrift,ydrift,0);
        camerapos.x=xpos;
        camerapos.y=ypos;
//System.out.println("hallo2");
        boolean loso=false;
        int xposb=(xpos+25)/50;
        int yposb=(ypos+25)/50;
        if(winstatus==0&&xposb>=0&&xposb<30&&yposb>=0&&yposb<18){
            if(screen[xposb][yposb]==4){
                screen[xposb][yposb]=0;
                treasures--;
                eng.remove(groupscreen[xposb][yposb]);
            }
            if(screen[xposb][yposb]==1){
                screen[xposb][yposb]=0;
                eng.remove(groupscreen[xposb][yposb]);
            }
            if(screen[xposb][yposb]==2){
                ydrift=-ydrift;
            }
            if(screen[xposb][yposb]==5){
                loso=true;
            }
            if(screen[xposb][yposb]==6){
                loso=true;
            }
            if(screen[xposb][yposb]==7){
                xdrift=(int)(Math.random()*20)-10;
                ydrift=(int)(Math.random()*20)-10;
            }
            if(screen[xposb][yposb]==8){
                all=true;
            }
            else{
                all=false;
            }
        }
//System.out.println("hallo3");
//System.out.println("hallo4");
        if(xpos<0||xpos>=1450){
            xdrift=-xdrift;
        }
        if(ypos<0||ypos>=850){
            ydrift=-ydrift;
        }
        if(treasures==0){
            if(winstatus==0){
                OpenLevelMpoint3D.app2.la.setText("You won!");
                winstatus=1;
            }
            if(endfirst){
                endfirst=false;
//                ol.show();
            }
//            eng.setStatus("You won!");
//            Loader mov=new Loader(m,"You won!");
//            Display d=Display.getDisplay(m);
//            d.setCurrent((Displayable)mov);
        }
        if(loso){
            lifes--;
            if(lifes<=0){
                if(winstatus==0){
                    OpenLevelMpoint3D.app2.la.setText("You lost!");
                    winstatus=2;
                }
                if(endfirst){
                    endfirst=false;
//                    ol.show();
                }
//                eng.setStatus("You lost!");
//                Loader mov=new Loader(m,"You lost!");
//                Display d=Display.getDisplay(m);
//                d.setCurrent((Displayable)mov);
            }
            else{
                player.transform(xstart-xpos,ystart-ypos,0);
                xpos=xstart;
                ypos=ystart;
                xdrift=0;
                ydrift=7;
            }
        }
//System.out.println("b");
//        h.drawImage(you,width/2+100,height/2+100,0);
//        g.drawImage(img,-100,-100,0);
    }
}
class PathPath{
    Path start;
    Path end;
    public boolean empty(){
        return (start==null);
    }
    public Path top(){
        Path ret=start;
        if(start!=null){
            start=start.next;
        }
        return ret;
    }
    public void add(Path p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
}
class Path{
    int cur=0;
    Path next;
    int[]xpoint=new int[0];
    int[]ypoint=new int[0];
    int[]drive=new int[0];
    int[][]level;
    int x;
    int y;
    boolean active;
    Group gegner;
    boolean first=true;
    int direction=0;
    int directionc=0;
    public Path(EngineMpoint3D eng,int[][]level,int x,int y){
        this.level=level;
        this.x=x;
        this.y=y;
        active=true;
        gegner=ObjectGenerator.getPac(Color.lightGray,Color.black,Color.darkGray,Color.black);
        gegner.transform(-25,-25,-25);
        gegner.rotLeft(Math.PI/2);
        gegner.transform(25,25,25);
        gegner.transform(x*50,y*50,0);
        eng.add(gegner);
    }
    public void newpath(){
        int ran1=(int)(Math.random()*30);
        if(ran1<0){
            ran1=-ran1;
        }
        int ran2=(int)(Math.random()*18);
        if(ran2<0){
            ran2=-ran2;
        }
        int x2=ran1;
        int y2=ran2;
        PathQueue pq=new PathQueue();
        boolean[][]visited=new boolean[30][18];
        pq.add(x,y,null);
        visited[x][y]=true;
        PathElem last=null;
        int end=(int)(Math.random()*20)+5;
        for(int i=0;i<end&&!pq.empty();i++){
            PathElem top=pq.top();
            last=top;
            int x3=top.x;
            int y3=top.y;
            if(x3+1>=0&&x3+1<30&&y3>=0&&y3<18&&!visited[x3+1][y3]&&level[x3+1][y3]==0){
                pq.add(x3+1,y3,top);
                visited[x3+1][y3]=true;
            }
            if(x3-1>=0&&x3-1<30&&y3>=0&&y3<18&&!visited[x3-1][y3]&&level[x3-1][y3]==0){
                pq.add(x3-1,y3,top);
                visited[x3-1][y3]=true;
            }
            if(x3>=0&&x3<30&&y3-1>=0&&y3-1<18&&!visited[x3][y3-1]&&level[x3][y3-1]==0){
                pq.add(x3,y3-1,top);
                visited[x3][y3-1]=true;
            }
            if(x3>=0&&x3<30&&y3+1>=0&&y3+1<18&&!visited[x3][y3+1]&&level[x3][y3+1]==0){
                pq.add(x3,y3+1,top);
                visited[x3][y3+1]=true;
            }
        }
        int count=0;
        PathElem cur=last;
        while(cur!=null){
            count++;
            cur=cur.fore;
        }
        int n=(count-1)*4+1;
        xpoint=new int[n];
        ypoint=new int[n];
        drive=new int[n];
        cur=last;
        boolean firstx=true;
        int directionca=0;
        for(int i=0;i<count-1;i++){
            PathElem cn=cur.fore;
            int xd=cn.x-cur.x;
            int yd=cn.y-cur.y;
            int directionb=0;
            if(xd>0&&yd==0){
                directionb=2;
            }
            if(xd==0&&yd>0){
                directionb=3;
            }
            if(xd<0&&yd==0){
                directionb=0;
            }
            if(xd==0&&yd<0){
                directionb=1;
            }
            if(direction!=directionb&&!firstx){
                if(direction==0&&directionb==1){
                    drive[i*4]=-4;
                }
                if(direction==0&&directionb==2){
                    drive[i*4]=8;
                }
                if(direction==0&&directionb==3){
                    drive[i*4]=4;
                }

                if(direction==1&&directionb==0){
                    drive[i*4]=4;
                }
                if(direction==1&&directionb==2){
                    drive[i*4]=-4;
                }
                if(direction==1&&directionb==3){
                    drive[i*4]=8;
                }

                if(direction==2&&directionb==0){
                    drive[i*4]=-8;
                }
                if(direction==2&&directionb==1){
                    drive[i*4]=4;
                }
                if(direction==2&&directionb==3){
                    drive[i*4]=-4;
                }

                if(direction==3&&directionb==0){
                    drive[i*4]=-4;
                }
                if(direction==3&&directionb==1){
                    drive[i*4]=8;
                }
                if(direction==3&&directionb==2){
                    drive[i*4]=4;
                }
                direction=directionb;
            }
            if(firstx){
                firstx=false;
                direction=directionb;
                directionca=directionb;
            }
            for(int j=0;j<4;j++){
                xpoint[i*4+j]=cur.x*50+xd*j*12;
                ypoint[i*4+j]=cur.y*50+yd*j*12;
            }
            cur=cur.fore;
        }



            int directioncb=direction;

            if(directioncb!=directionc){
                if(directionc==0&&directioncb==1){
                    drive[n-1]=4;
                }
                if(directionc==0&&directioncb==2){
                    drive[n-1]=8;
                }
                if(directionc==0&&directioncb==3){
                    drive[n-1]=-4;
                }

                if(directionc==1&&directioncb==0){
                    drive[n-1]=-4;
                }
                if(directionc==1&&directioncb==2){
                    drive[n-1]=4;
                }
                if(directionc==1&&directioncb==3){
                    drive[n-1]=8;
                }

                if(directionc==2&&directioncb==0){
                    drive[n-1]=-8;
                }
                if(directionc==2&&directioncb==1){
                    drive[n-1]=-4;
                }
                if(directionc==2&&directioncb==3){
                    drive[n-1]=4;
                }

                if(directionc==3&&directioncb==0){
                    drive[n-1]=4;
                }
                if(directionc==3&&directioncb==1){
                    drive[n-1]=8;
                }
                if(directionc==3&&directioncb==2){
                    drive[n-1]=-4;
                }
            }

        directionc=directionca;
        direction=directionca;
        xpoint[n-1]=cur.x*50;
        ypoint[n-1]=cur.y*50;
        int[]xpoint2=new int[n];
        int[]ypoint2=new int[n];
        int[]drive2=new int[n];
        for(int i=0;i<n;i++){
            xpoint2[i]=xpoint[n-1-i];
            ypoint2[i]=ypoint[n-1-i];
            drive2[i]=drive[n-1-i];
        }
        xpoint=xpoint2;
        ypoint=ypoint2;
        drive=drive2;
        x=xpoint[n-1]/50;
        y=ypoint[n-1]/50;
        this.cur=0;
    }
}
class PathQueue{
    PathElem start;
    PathElem end;
    public boolean empty(){
        return (start==null);
    }
    public PathElem top(){
        PathElem ret=start;
        if(start!=null){
            start=start.next;
        }
        return ret;
    }
    public void add(int x,int y,PathElem fore){
        PathElem np=new PathElem(x,y,fore);
        if(start==null){
            start=np;
            end=np;
        }
        else{
            end.next=np;
            end=end.next;
        }
    }
}
class PathElem{
    PathElem next;
    PathElem fore;
    int x;
    int y;
    public PathElem(int x,int y,PathElem fore){
        this.x=x;
        this.y=y;
        this.fore=fore;
    }
}
class Bomb{
    int cur;
    boolean yours;
    int x;
    int y;
    Group bomb;
    Group explosion;
    boolean isnew=true;
    public Bomb(int x,int y,boolean yours){
        this.x=x;
        this.y=y;
        this.yours=yours;
        cur=40;
        bomb=ObjectGenerator.getBomb();
//        explosion=ObjectGenerator.getExplosion();
        bomb.transform(x*50,y*50,0);
//        explosion.transform(x*50,y*50,0);
    }
    public void inserted(){
        isnew=false;
    }
}
class ObjectGenerator{
    public static Group getBoden(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.darkGray,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,0);
        Vektor v6=new Vektor(40,10,0);
        Vektor v7=new Vektor(40,40,0);
        Vektor v8=new Vektor(10,40,0);
        Quad q2=new Quad(Color.gray,Color.gray,v5,v6,v7,v8);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getKugel1(){
        Vektor v1=new Vektor(25,25,25);
        Kugel k=new Kugel(Color.lightGray,Color.lightGray,v1,10);
        Group g=new Group();
        g.add(k);
        return g;
    }
    public static Group getKugel2(){
        Vektor v1=new Vektor(25,25,25);
        Kugel k=new Kugel(Color.green,Color.green,v1,10);
        Group g=new Group();
        g.add(k);
        return g;
    }
    public static Group getSoftStone(){
        Vektor v1=new Vektor(5,5,25);
        Vektor v2=new Vektor(45,5,25);
        Vektor v3=new Vektor(45,45,25);
        Vektor v4=new Vektor(5,45,25);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,25);
        Vektor v6=new Vektor(40,10,25);
        Vektor v7=new Vektor(40,40,25);
        Vektor v8=new Vektor(10,40,25);
        Quad q2=new Quad(Color.yellow,Color.yellow,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,25);
        Vektor v12=new Vektor(5,5,25);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,25);
        Vektor v16=new Vektor(5,5,25);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,25);
        Vektor v20=new Vektor(5,45,25);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,25);
        Vektor v24=new Vektor(45,5,25);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getHardStone(){
        Vektor v1=new Vektor(5,5,40);
        Vektor v2=new Vektor(45,5,40);
        Vektor v3=new Vektor(45,45,40);
        Vektor v4=new Vektor(5,45,40);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,40);
        Vektor v6=new Vektor(40,10,40);
        Vektor v7=new Vektor(40,40,40);
        Vektor v8=new Vektor(10,40,40);
        Quad q2=new Quad(Color.red,Color.red,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,40);
        Vektor v12=new Vektor(5,5,40);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,40);
        Vektor v16=new Vektor(5,5,40);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,40);
        Vektor v20=new Vektor(5,45,40);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,40);
        Vektor v24=new Vektor(45,5,40);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getLoch(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.black,Color.black,v1,v2,v3,v4);
        Group g=new Group();
        g.add(q1);
        return g;
    }
    public static Group getAll(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.black,Color.black,v1,v2,v3,v4);
        Vektor v1b=new Vektor(10,10,0);
        Vektor v2b=new Vektor(40,10,0);
        Vektor v3b=new Vektor(40,40,0);
        Vektor v4b=new Vektor(10,40,0);
        Quad q1b=new Quad(Color.yellow,Color.red,v1b,v2b,v3b,v4b);
        Group gb=new Group();
        gb.add(q1b);
        return gb;
    }
    public static Group getPirat(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(25,25,40);
        Vektor v3=new Vektor(50,0,0);
        Triangle t1=new Triangle(Color.red,Color.black,v1,v2,v3);
        Vektor v4=new Vektor(50,0,0);
        Vektor v5=new Vektor(25,25,40);
        Vektor v6=new Vektor(50,50,0);
        Triangle t2=new Triangle(Color.red,Color.black,v4,v5,v6);
        Vektor v7=new Vektor(50,50,0);
        Vektor v8=new Vektor(25,25,40);
        Vektor v9=new Vektor(0,50,0);
        Triangle t3=new Triangle(Color.red,Color.black,v7,v8,v9);
        Vektor v10=new Vektor(0,50,0);
        Vektor v11=new Vektor(25,25,40);
        Vektor v12=new Vektor(0,0,0);
        Triangle t4=new Triangle(Color.red,Color.black,v10,v11,v12);
        Group g=new Group();
        g.add(t1);
        g.add(t2);
        g.add(t3);
        g.add(t4);
        return g;
    }
    public static Group getSchleuder(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.blue,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,5);
        Vektor v6=new Vektor(45,5,5);
        Vektor v7=new Vektor(45,45,5);
        Vektor v8=new Vektor(5,45,5);
        Quad q2=new Quad(Color.red,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(10,10,10);
        Vektor v10=new Vektor(40,10,10);
        Vektor v11=new Vektor(40,40,10);
        Vektor v12=new Vektor(10,40,10);
        Quad q3=new Quad(Color.yellow,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(15,15,15);
        Vektor v14=new Vektor(35,15,15);
        Vektor v15=new Vektor(35,35,15);
        Vektor v16=new Vektor(15,35,15);
        Quad q4=new Quad(Color.green,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(20,20,20);
        Vektor v18=new Vektor(30,20,20);
        Vektor v19=new Vektor(30,30,20);
        Vektor v20=new Vektor(20,30,20);
        Quad q5=new Quad(Color.blue,Color.black,v17,v18,v19,v20);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        return g;
    }
    public static Group getPoint(){
        Vektor v1=new Vektor(5,5,25);
        Vektor v2=new Vektor(45,5,25);
        Vektor v3=new Vektor(45,45,25);
        Vektor v4=new Vektor(5,45,25);
        Quad q1=new Quad(Color.blue,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,25);
        Vektor v6=new Vektor(40,10,25);
        Vektor v7=new Vektor(40,40,25);
        Vektor v8=new Vektor(10,40,25);
        Quad q2=new Quad(Color.orange,Color.red,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,25);
        Vektor v12=new Vektor(5,5,25);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,25);
        Vektor v16=new Vektor(5,5,25);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,25);
        Vektor v20=new Vektor(5,45,25);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,25);
        Vektor v24=new Vektor(45,5,25);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getPlayer(){
        Vektor v1=new Vektor(5,5,25);
        Vektor v2=new Vektor(45,5,25);
        Vektor v3=new Vektor(45,45,25);
        Vektor v4=new Vektor(5,45,25);
        Quad q1=new Quad(Color.blue,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,25);
        Vektor v6=new Vektor(40,10,25);
        Vektor v7=new Vektor(40,40,25);
        Vektor v8=new Vektor(10,40,25);
        Quad q2=new Quad(Color.green,Color.green,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,25);
        Vektor v12=new Vektor(5,5,25);
        Quad q3=new Quad(Color.blue,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(10,5,10);
        Vektor v14=new Vektor(40,5,10);
        Vektor v15=new Vektor(40,5,20);
        Vektor v16=new Vektor(10,5,20);
        Quad q4=new Quad(Color.green,Color.green,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,5);
        Vektor v18=new Vektor(5,45,5);
        Vektor v19=new Vektor(5,45,25);
        Vektor v20=new Vektor(5,5,25);
        Quad q5=new Quad(Color.blue,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(5,10,10);
        Vektor v22=new Vektor(5,40,10);
        Vektor v23=new Vektor(5,40,20);
        Vektor v24=new Vektor(5,10,20);
        Quad q6=new Quad(Color.green,Color.green,v21,v22,v23,v24);
        Vektor v25=new Vektor(5,45,5);
        Vektor v26=new Vektor(45,45,5);
        Vektor v27=new Vektor(45,45,25);
        Vektor v28=new Vektor(5,45,25);
        Quad q7=new Quad(Color.blue,Color.black,v25,v26,v27,v28);
        Vektor v29=new Vektor(10,45,10);
        Vektor v30=new Vektor(40,45,10);
        Vektor v31=new Vektor(40,45,20);
        Vektor v32=new Vektor(10,45,20);
        Quad q8=new Quad(Color.green,Color.green,v29,v30,v31,v32);
        Vektor v33=new Vektor(45,5,5);
        Vektor v34=new Vektor(45,45,5);
        Vektor v35=new Vektor(45,45,25);
        Vektor v36=new Vektor(45,5,25);
        Quad q9=new Quad(Color.blue,Color.black,v33,v34,v35,v36);
        Vektor v37=new Vektor(45,10,10);
        Vektor v38=new Vektor(45,40,10);
        Vektor v39=new Vektor(45,40,20);
        Vektor v40=new Vektor(45,10,20);
        Quad q10=new Quad(Color.green,Color.green,v37,v38,v39,v40);
        Vektor v41=new Vektor(25,25,37);
        Kugel kug=new Kugel(Color.red,Color.red,v41,12);
        PaintGroup p1=new PaintGroup();
        q1.setPaintGroup(p1);
        q2.setPaintGroup(p1);
        PaintGroup p2=new PaintGroup();
        q3.setPaintGroup(p2);
        q4.setPaintGroup(p2);
        PaintGroup p3=new PaintGroup();
        q5.setPaintGroup(p3);
        q6.setPaintGroup(p3);
        PaintGroup p4=new PaintGroup();
        q7.setPaintGroup(p4);
        q8.setPaintGroup(p4);
        PaintGroup p5=new PaintGroup();
        q9.setPaintGroup(p5);
        q10.setPaintGroup(p5);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        g.add(q8);
        g.add(q9);
        g.add(q10);
        g.add(kug);
        return g;
    }
    public static Group getGegner(){
        Vektor v1=new Vektor(5,5,5);
        Vektor v2=new Vektor(45,5,5);
        Vektor v3=new Vektor(25,25,25);
        Triangle t1=new Triangle(Color.darkGray,Color.black,v1,v2,v3);
        Vektor v4=new Vektor(5,5,5);
        Vektor v5=new Vektor(5,45,5);
        Vektor v6=new Vektor(25,25,25);
        Triangle t2=new Triangle(Color.darkGray,Color.black,v4,v5,v6);
        Vektor v7=new Vektor(5,45,5);
        Vektor v8=new Vektor(45,45,5);
        Vektor v9=new Vektor(25,25,25);
        Triangle t3=new Triangle(Color.darkGray,Color.black,v7,v8,v9);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,45,5);
        Vektor v12=new Vektor(25,25,25);
        Triangle t4=new Triangle(Color.darkGray,Color.black,v10,v11,v12);
        Vektor v13=new Vektor(25,25,37);
        Kugel kug=new Kugel(Color.lightGray,Color.lightGray,v13,12);
        Group g=new Group();
        g.add(t1);
        g.add(t2);
        g.add(t3);
        g.add(t4);
        g.add(kug);
        return g;
    }
    public static Group getBomb(){
        Vektor v1=new Vektor(25,25,25);
        Kugel kug=new Kugel(Color.black,Color.black,v1,25);
        Group g=new Group();
        g.add(kug);
        return g;
    }
    public static Group getKugel(){
        Vektor v1=new Vektor(25,25,25);
        Kugel kug=new Kugel(Color.blue,Color.blue,v1,20);
        Group g=new Group();
        g.add(kug);
        return g;
    }
    public static Group getExplosion(){
        Vektor v1=new Vektor(0,0,50);
        Vektor v2=new Vektor(50,0,50);
        Vektor v3=new Vektor(50,50,50);
        Vektor v4=new Vektor(0,50,50);
        Quad q1=new Quad(Color.red,Color.red,v1,v2,v3,v4);
        Vektor v5=new Vektor(0,0,0);
        Vektor v6=new Vektor(50,0,0);
        Vektor v7=new Vektor(50,0,50);
        Vektor v8=new Vektor(0,0,50);
        Quad q2=new Quad(Color.red,Color.red,v5,v6,v7,v8);
        Vektor v9=new Vektor(0,0,0);
        Vektor v10=new Vektor(0,50,0);
        Vektor v11=new Vektor(0,50,50);
        Vektor v12=new Vektor(0,0,50);
        Quad q3=new Quad(Color.red,Color.red,v9,v10,v11,v12);
        Vektor v13=new Vektor(0,50,0);
        Vektor v14=new Vektor(50,50,0);
        Vektor v15=new Vektor(50,50,50);
        Vektor v16=new Vektor(0,50,50);
        Quad q4=new Quad(Color.red,Color.red,v13,v14,v15,v16);
        Vektor v17=new Vektor(50,0,0);
        Vektor v18=new Vektor(50,50,0);
        Vektor v19=new Vektor(50,50,50);
        Vektor v20=new Vektor(50,0,50);
        Quad q5=new Quad(Color.red,Color.red,v17,v18,v19,v20);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        return g;
    }
    public static Group getPac(Color inner,Color outer,Color mouth,Color eyes){
//Ring waagerecht
        Vektor v1=new Vektor(7,17,17);
        Vektor v2=new Vektor(7,33,17);
        Vektor v3=new Vektor(7,33,33);
        Vektor v4=new Vektor(7,17,33);

        Vektor v5=new Vektor(17,7,17);
        Vektor v6=new Vektor(7,17,17);
        Vektor v7=new Vektor(7,17,33);
        Vektor v8=new Vektor(17,7,33);

        Vektor v9=new Vektor(17,43,17);
        Vektor v10=new Vektor(17,43,33);
        Vektor v11=new Vektor(7,33,33);
        Vektor v12=new Vektor(7,33,17);

        Vektor v13=new Vektor(17,43,17);
        Vektor v14=new Vektor(33,43,17);
        Vektor v15=new Vektor(33,43,33);
        Vektor v16=new Vektor(17,43,33);

        Vektor v17=new Vektor(33,43,17);
        Vektor v18=new Vektor(33,43,33);
        Vektor v19=new Vektor(43,33,33);
        Vektor v20=new Vektor(43,33,17);

        Vektor v21=new Vektor(43,33,33);
        Vektor v22=new Vektor(43,33,17);
        Vektor v23=new Vektor(43,17,17);
        Vektor v24=new Vektor(43,17,33);

        Vektor v25=new Vektor(43,17,17);
        Vektor v26=new Vektor(43,17,33);
        Vektor v27=new Vektor(33,7,33);
        Vektor v28=new Vektor(33,7,17);

//Ring senkrecht ohne Ring waagerecht
        Vektor v29=new Vektor(7,17,33);
        Vektor v30=new Vektor(7,33,33);
        Vektor v31=new Vektor(17,33,43);
        Vektor v32=new Vektor(17,17,43);

        Vektor v33=new Vektor(17,33,43);
        Vektor v34=new Vektor(17,17,43);
        Vektor v35=new Vektor(33,17,43);
        Vektor v36=new Vektor(33,33,43);

        Vektor v37=new Vektor(33,17,43);
        Vektor v38=new Vektor(33,33,43);
        Vektor v39=new Vektor(43,33,33);
        Vektor v40=new Vektor(43,17,33);

        Vektor v41=new Vektor(43,33,17);
        Vektor v42=new Vektor(43,17,17);
        Vektor v43=new Vektor(33,17,7);
        Vektor v44=new Vektor(33,33,7);

        Vektor v45=new Vektor(17,17,7);
        Vektor v46=new Vektor(17,33,7);
        Vektor v47=new Vektor(7,33,17);
        Vektor v48=new Vektor(7,17,17);

//Restring additional
        Vektor w1=new Vektor(17,7,33);
        Vektor w2=new Vektor(33,7,33);
        Vektor w3=new Vektor(33,17,43);
        Vektor w4=new Vektor(17,17,43);

        Vektor w5=new Vektor(17,33,43);
        Vektor w6=new Vektor(33,33,43);
        Vektor w7=new Vektor(33,43,33);
        Vektor w8=new Vektor(17,43,33);

        Vektor w9=new Vektor(17,33,7);
        Vektor w10=new Vektor(33,33,7);
        Vektor w11=new Vektor(33,43,17);
        Vektor w12=new Vektor(17,43,17);

        Vektor w13=new Vektor(17,7,17);
        Vektor w14=new Vektor(33,7,17);
        Vektor w15=new Vektor(33,17,7);
        Vektor w16=new Vektor(17,17,7);

//die acht Seitenflchen
//oben
        Vektor v49=new Vektor(17,17,43);
        Vektor v50=new Vektor(7,17,33);
        Vektor v51=new Vektor(17,7,33);

        Vektor v52=new Vektor(17,33,43);
        Vektor v53=new Vektor(7,33,33);
        Vektor v54=new Vektor(17,43,33);

        Vektor v55=new Vektor(33,33,43);
        Vektor v56=new Vektor(43,33,33);
        Vektor v57=new Vektor(33,43,33);

        Vektor v58=new Vektor(33,17,43);
        Vektor v59=new Vektor(43,17,33);
        Vektor v60=new Vektor(33,7,33);
//unten
        Vektor v61=new Vektor(17,17,7);
        Vektor v62=new Vektor(7,17,17);
        Vektor v63=new Vektor(17,7,17);

        Vektor v64=new Vektor(17,33,7);
        Vektor v65=new Vektor(7,33,17);
        Vektor v66=new Vektor(17,43,17);

        Vektor v67=new Vektor(33,33,7);
        Vektor v68=new Vektor(43,33,17);
        Vektor v69=new Vektor(33,43,17);

        Vektor v70=new Vektor(33,17,7);
        Vektor v71=new Vektor(43,17,17);
        Vektor v72=new Vektor(33,7,17);

//mouth
        Vektor v73=new Vektor(17,7,17);
        Vektor v74=new Vektor(25,25,25);
        Vektor v75=new Vektor(17,7,33);

        Vektor v76=new Vektor(33,7,17);
        Vektor v77=new Vektor(25,25,25);
        Vektor v78=new Vektor(33,7,33);

        Vektor v79=new Vektor(17,7,17);
        Vektor v80=new Vektor(25,25,25);
        Vektor v81=new Vektor(33,7,17);

        Vektor v82=new Vektor(33,7,33);
        Vektor v83=new Vektor(25,25,25);
        Vektor v84=new Vektor(17,7,33);

//eyes
        Vektor v85=new Vektor(10,10,38);
        Vektor v86=new Vektor(40,10,38);

        Quad q1=new Quad(inner,outer,v1,v2,v3,v4);
        Quad q2=new Quad(inner,outer,v5,v6,v7,v8);
        Quad q3=new Quad(inner,outer,v9,v10,v11,v12);
        Quad q4=new Quad(inner,outer,v13,v14,v15,v16);
        Quad q5=new Quad(inner,outer,v17,v18,v19,v20);
        Quad q6=new Quad(inner,outer,v21,v22,v23,v24);
        Quad q7=new Quad(inner,outer,v25,v26,v27,v28);
        Quad q8=new Quad(inner,outer,v29,v30,v31,v32);
        Quad q9=new Quad(inner,outer,v33,v34,v35,v36);
        Quad q10=new Quad(inner,outer,v37,v38,v39,v40);
        Quad q11=new Quad(inner,outer,v41,v42,v43,v44);
        Quad q12=new Quad(inner,outer,v45,v46,v47,v48);

        Quad qb1=new Quad(inner,outer,w1,w2,w3,w4);
        Quad qb2=new Quad(inner,outer,w5,w6,w7,w8);
        Quad qb3=new Quad(inner,outer,w9,w10,w11,w12);
        Quad qb4=new Quad(inner,outer,w13,w14,w15,w16);

        Triangle t1=new Triangle(inner,outer,v49,v50,v51);
        Triangle t2=new Triangle(inner,outer,v52,v53,v54);
        Triangle t3=new Triangle(inner,outer,v55,v56,v57);
        Triangle t4=new Triangle(inner,outer,v58,v59,v60);
        Triangle t5=new Triangle(inner,outer,v61,v62,v63);
        Triangle t6=new Triangle(inner,outer,v64,v65,v66);
        Triangle t7=new Triangle(inner,outer,v67,v68,v69);
        Triangle t8=new Triangle(inner,outer,v70,v71,v72);

        Triangle t9=new Triangle(mouth,outer,v73,v74,v75);
        Triangle t10=new Triangle(mouth,outer,v76,v77,v78);
        Triangle t11=new Triangle(mouth,outer,v79,v80,v81);
        Triangle t12=new Triangle(mouth,outer,v82,v83,v84);

        Kugel k1=new Kugel(eyes,eyes,v85,5);
        Kugel k2=new Kugel(eyes,eyes,v86,5);

        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        g.add(q8);
        g.add(q9);
        g.add(q10);
        g.add(q11);
        g.add(q12);
        g.add(qb1);
        g.add(qb2);
        g.add(qb3);
        g.add(qb4);
        g.add(t1);
        g.add(t2);
        g.add(t3);
        g.add(t4);
        g.add(t5);
        g.add(t6);
        g.add(t7);
        g.add(t8);
        g.add(t9);
        g.add(t10);
        g.add(t11);
        g.add(t12);
        g.add(k1);
        g.add(k2);
        return g;
    }
}
class EngineMpoint3D extends JPanel{
    Thread t;
    ImageFrameMpoint3D imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -3248559261959425469L;
    public EngineMpoint3D(){
        imf=new ImageFrameMpoint3D();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
//    public synchronized void paint(Graphics g){
//        if(first){
//            return;
//        }
//    }
    public synchronized void paint(Graphics g){
        if(first){
            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
//        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameMpoint3D extends JFrame{
    Image img;
    private static final long serialVersionUID = -7056513742949639722L;
    public ImageFrameMpoint3D(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
