import java.io.*;
import java.awt.*;
import java.net.*;
import java.applet.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
public class AstroJump extends JApplet implements Runnable,ActionListener,KeyListener{
    Thread t;
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    JButton start;
    JButton start2;
    JPanel p1;
    XScreen p2;
    KeyboardMapperAppletSwing km=null;
    boolean startb=false;
    boolean start2b=false;
    MediaTracker tracker;
    static JApplet app;
    static AstroJump app2;
    Loadera loa;
    private static final long serialVersionUID = -6427285688432764349L;
    public static XScreen forward;
    public void init(){
        resize(640,680);
        app=this;
        app2=this;
        setLayout(null);
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        start=new JButton("two players");
        start2=new JButton("one player");
        p1=new JPanel();
        p1.setLayout(null);
        p1.add(spl);
        p1.add(start);
        p1.add(start2);
        spl.setBounds(10,40,380,280);
        start.setBounds(10,330,380,27);
        start2.setBounds(10,360,380,27);
        add(p1);
        p1.setBounds(0,0,400,400);
        setFocusable(true);
        requestFocus();
        setVisible(true);
        load();
        start.addActionListener(this);
        start2.addActionListener(this);
        addKeyListener(this); 
        t=new Thread(this);
        t.start();
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        requestFocus();
//System.out.println("egetkeycode "+e.getKeyCode());
        if(forward!=null){
            forward.process(e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void load(){
        try{
            InputStream fis=AstroJump.getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp="";
//            l.removeAll();
            lcontent=new Vector<String>();
            while((inp=dis.readLine())!=null){
                lcontent.addElement(inp);
            }
            l.setListData(lcontent);
            fis.close();
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
    }
    public void run(){
        p1.setVisible(false);
        km=new KeyboardMapperAppletSwing(this);
        add(km);
        km.setBounds(0,40,400,400);
        km.setVisible(true);
        while(!km.closed){
            try{
                Thread.sleep(100);
            }
            catch(Exception e){
            }
        }
        p1.setVisible(true);
        while(true){
            try{
                Thread.sleep(100);
                if(startb){
                    startb=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1&&ind<lcontent.size()){
                         new Loadera(lcontent.elementAt(ind),false);
                    }
                }
                if(start2b){
                    start2b=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1&&ind<lcontent.size()){
                         new Loadera(lcontent.elementAt(ind),true);
                    }
                }
            }
            catch(Exception e){
            }
        }
    }
    public static void main(String[]args){
        new AstroJump();
    }
    public void actionPerformed(ActionEvent e){
        if(e.getSource()==start){
            startb=true;
        }
        if(e.getSource()==start2){
            start2b=true;
        }
    }
}
class Loadera implements Runnable{
    String level;
    Thread t;
    int xl;
    int yl;
    int[][]backgr;
    String[][]objs;
    StringHolder sh;
    StringHolder sh2;
    StringPair sp;
    StringPair sp2;
    int figures;
    int objects;
    JumpObject[]jumpo;
    FigureObject[]figo;
    FigureObject player1;
    FigureObject player2;
    Kugel[]kugel=new Kugel[200];
    Image back;
    Image stone;
    boolean one=false;
    public Loadera(String level,boolean one){
        this.level=level;
        this.one=one;
        AstroJump.app2.tracker=new MediaTracker(AstroJump.app2);
        sh=new StringHolder();
        sh2=new StringHolder();
        sp=new StringPair();
        sp2=new StringPair();
        player1=new FigureObject("player1.fig");
        player2=new FigureObject("player2.fig");
        Frame f=new Frame();
        try{
            back=AstroJump.getImage("back.gif");
            stone=AstroJump.getImage("stone.gif");
            AstroJump.app2.tracker.addImage(back,0);
            AstroJump.app2.tracker.addImage(stone,0);
        }
        catch(Exception e){
        }
        t=new Thread(this);
        t.start();
    }
    public void createKugel(boolean yours,double x,double y,double xdrift,double ydrift){
        int c=0;
        while(c<200&&kugel[c]!=null&&!kugel[c].off){
            c++;
        }
        if(c==200){
            c=(int)(Math.random()*200);
        }
        kugel[c]=new Kugel(yours,x,y,xdrift,ydrift);
    }
    public void run(){
        try{
            InputStream fis=AstroJump.getInputStream(level);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String s=dis.readLine();
            xl=new Integer(dis.readLine()).intValue();
            yl=new Integer(dis.readLine()).intValue();
            backgr=new int[xl][yl];
            objs=new String[xl][yl];
            for(int i=0;i<xl;i++){
                for(int j=0;j<yl;j++){
                    s=dis.readLine();
                    if("s".equals(s)){
                        backgr[i][j]=1;
                    }
                    else if("start1".equals(s)){
                        backgr[i][j]=2;
                        player1.x=i*40;
                        player1.y=j*40+40;
                        player1.xs=i*40;
                        player1.ys=j*40+40;
                    }
                    else if("start2".equals(s)){
                        backgr[i][j]=3;
                        player2.x=i*40;
                        player2.y=j*40+40;
                        player2.xs=i*40;
                        player2.ys=j*40+40;
                    }
                    else if("f".equals(s)){
                        objs[i][j]=dis.readLine();
                        backgr[i][j]=4;
                        sh.add(objs[i][j]);
                        figures++;
                    }
                    else if("o".equals(s)){
                        objs[i][j]=dis.readLine();
                        backgr[i][j]=5;
                        sh2.add(objs[i][j]);
                        objects++;
                    }
                }
            }
            fis.close();
            for(int i=0;i<sh.s.length;i++){
                FigureObject fi=new FigureObject(sh.s[i]);
                sp.add(sh.s[i],fi);
            }
            for(int i=0;i<sh2.s.length;i++){
                JumpObject fi=new JumpObject(sh2.s[i]);
                sp2.add(sh2.s[i],fi);
            }
            figo=new FigureObject[figures];
            int c=0;
            for(int i=0;i<xl;i++){
                for(int j=0;j<yl;j++){
                    if(backgr[i][j]==4){
                        FigureObject fio=(FigureObject)sp.getObj(objs[i][j]);
                        figo[c]=fio.cloneo();
                        figo[c].x=i*40;
                        figo[c].y=j*40+40;
                        figo[c].xdrift=figo[c].speed;
                        c++;
                    }
                }
            }
            jumpo=new JumpObject[objects];
            c=0;
            for(int i=0;i<xl;i++){
                for(int j=0;j<yl;j++){
                    if(backgr[i][j]==5){
                        JumpObject fio=(JumpObject)sp2.getObj(objs[i][j]);
                        jumpo[c]=fio.cloneo();
                        jumpo[c].x=i*40;
                        jumpo[c].y=j*40;
                        c++;
                    }
                }
            }
            AstroJump.app2.tracker.waitForID(0);
            AstroJump.app2.p1.setVisible(false);
            AstroJump.app2.p2=new XScreen(this,one);
            AstroJump.forward=AstroJump.app2.p2;
            AstroJump.app2.add(AstroJump.app2.p2);
            if(one){
                AstroJump.app2.p2.setBounds(0,0,640,380);
            }
            else{
                AstroJump.app2.p2.setBounds(0,0,640,680);
            }
        }
        catch(Exception e){
            System.out.println("level load error: "+e);
        }
    }
}
class XScreen extends JPanel implements Runnable{
    Thread t;
    Canv canv1;
    Canv canv2;
    Loadera loa;
    boolean running=true;
    int left2=89;
    int right2=67;
    int up2=83;
    int down2=88;
    int ok=0;
    int enter2=65;
    boolean wonf=false;
    int points1=0;
    int points2=0;
    boolean one=false;
    private static final long serialVersionUID = -3076970008181535256L;
    public XScreen(Loadera loa,boolean one){
//        super("Astro Solutions AstroJump");
        this.one=one;
//        pack();
        if(!one){
            setSize(640,680);
        }
        else{
            setSize(640,360);
        }
        setLayout(null);
        this.loa=loa;
        canv1=new Canv(loa,false);
        canv2=new Canv(loa,true);
        add(canv1);
        if(!one){
            add(canv2);
        }
        canv1.setBounds(0,40,640,320);
        if(!one){
            canv2.setBounds(0,360,640,320);
        }
        setVisible(true);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(running){
            try{
                Thread.sleep(50);
                if(loa.player1.lifes==0){
                    canv1.info="player 1 has lost";
                }
                if(loa.player2.lifes==0){
                    canv2.info="player 2 has lost";
                }
                boolean won=true;
                for(int i=0;i<loa.figo.length;i++){
                    if(!loa.figo[i].dead){
                        won=false;
                    }
                }
                if(won){
                    if(!wonf){
                        wonf=true;
                        points1=(int)loa.player1.points;
                        points2=(int)loa.player2.points;
                    }
                    canv1.info="you have won! points: "+points1;
                    canv2.info="you have won! points: "+points2;
                }
                canv1.repaint();
                canv2.repaint();
            }
            catch(Exception e){
            }
        }
    }
    public void process2(KeyEvent e){
        canv2.process2(this,e);
    }
    public void process(KeyEvent e){
        canv1.process(this,e);
    }
    public void process3(KeyEvent evt){
        int key=evt.getKeyCode();
        if(AstroJump.app2.km!=null&&AstroJump.app2.km.applyb){
            key=AstroJump.app2.km.getKeyCode(key);
        }
//        if(evt.id==Event.WINDOW_DESTROY){
//            hide();
//            running=false;
//        }
//        if(evt.id==Event.KEY_PRESS||evt.id==Event.KEY_ACTION){
            if(key==27){
                setVisible(false);
                AstroJump.app2.p1.setVisible(true);
                running=false;
            }
            if(key==KeyEvent.VK_LEFT&&loa.player1.xdrift>-12){
                loa.player1.xdrift--;
            }
            if(key==KeyEvent.VK_RIGHT&&loa.player1.xdrift<12){
                loa.player1.xdrift++;
            }
            if(key==KeyEvent.VK_UP){
                if(loa.player1.canjump){
                    loa.player1.startjump();
                }
                else{
                    loa.player1.ydrift-=0.15;
                }
            }
            if(key==KeyEvent.VK_DOWN){
                loa.player1.ydrift+=0.15;
            }
            if(key==KeyEvent.VK_ENTER){
                loa.createKugel(true,loa.player1.x+20,loa.player1.y-20,loa.player1.xdrift*(loa.player1.gunadd+1)/0.5,0);
            }
            if(key==left2&&loa.player2.xdrift>-12){
                loa.player2.xdrift--;
            }
            if(key==right2&&loa.player2.xdrift<12){
                loa.player2.xdrift++;
            }
            if(key==up2){
                if(loa.player2.canjump){
                    loa.player2.startjump();
                }
                else{
                    loa.player2.ydrift-=0.15;
                }
            }
            if(key==down2){
                loa.player2.ydrift+=0.15;
            }
            if(key==enter2){
                loa.createKugel(true,loa.player2.x+20,loa.player2.y-20,loa.player2.xdrift*(loa.player2.gunadd+1)/0.5,0);
            }
//        }
//        return false;
    }
}
class Canv extends JPanel{
    Loadera loa;
    boolean two;
    Image img;
    int width=640;
    int height=320;
    Graphics h;
    FigureObject player1;
    FigureObject player2;
    String info="";
    private static final long serialVersionUID = -168363606639357570L;
    public Canv(Loadera loa,boolean two){
        this.two=two;
        this.loa=loa;
        player1=loa.player1;
        player2=loa.player2;
        ImFrameAppl imf=new ImFrameAppl(loa.xl,loa.yl);
        img=imf.img;
        h=img.getGraphics();
    }
    public synchronized void process(XScreen xsaj,KeyEvent e){
        xsaj.process2(e);
    }
    public synchronized void process2(XScreen xsaj,KeyEvent e){
        xsaj.process3(e);
    }
//    public void paint(Graphics g){
//    }
    public synchronized void paint(Graphics g){
        h.setColor(Color.white);
        h.fillRect(0,0,200+loa.xl*40,200+loa.yl*40);
        int xpos=(int)loa.player1.x;
        int ypos=(int)loa.player1.y-40;
        if(two){
            xpos=(int)loa.player2.x;
            ypos=(int)loa.player2.y-40;
        }
        int xl=loa.xl;
        int yl=loa.yl;
        int[][]backgr=loa.backgr;
        int xposc=(xpos-width/2-40)/40;
        int yposc=(ypos-height/2-40)/40;
        int wxc=(width+80)/40;
        int wyc=(height+80)/40;
        for(int i=xposc;i<xposc+wxc;i++){
            for(int j=yposc;j<yposc+wyc;j++){
                if(i>=0&&i<xl&&j>=0&&j<yl){
                    if(backgr[i][j]!=1){
                        h.drawImage(loa.back,100+i*40,100+j*40,this);
                    }
                    else if(backgr[i][j]==1){
                        h.drawImage(loa.stone,100+i*40,100+j*40,this);
                    }
                }
            }
        }
        JumpObject[]jo=loa.jumpo;
        for(int i=0;i<jo.length;i++){
            if(two){
                if(loa.player2.x+20>=jo[i].x&&loa.player2.x+20<jo[i].x+40){
                    if(!jo[i].off&&loa.player2.y-20>=jo[i].y&&loa.player2.y-20<jo[i].y+40){
                        loa.player2.lifes+=jo[i].lifes;
                        loa.player2.points+=jo[i].points;
                        jo[i].pos=1;
                        loa.player2.faster+=jo[i].faster;
                        loa.player2.gunadd+=jo[i].gunadd;
                        jo[i].off=true;
                    }
                }
            }
            else{
                if(loa.player1.x+20>=jo[i].x&&loa.player1.x+20<jo[i].x+40){
                    if(!jo[i].off&&loa.player1.y-20>=jo[i].y&&loa.player1.y-20<jo[i].y+40){
                        loa.player1.lifes+=jo[i].lifes;
                        loa.player1.points+=jo[i].points;
                        jo[i].pos=1;
                        loa.player1.faster+=jo[i].faster;
                        loa.player1.gunadd+=jo[i].gunadd;
                        jo[i].off=true;
                    }
                }
            }
            if(jo[i].pos==0){
                h.drawImage(jo[i].pic,100+jo[i].x,100+jo[i].y,this);
            }
            else if(jo[i].pos<=20){
                h.setColor(Color.blue);
                h.drawString(""+jo[i].points,100+jo[i].x+jo[i].pos*4,100+jo[i].y-jo[i].pos*8);
                jo[i].pos++;
            }
        }
        Kugel[]kugel=loa.kugel;
        FigureObject[]fo=loa.figo;
        for(int i=0;i<fo.length;i++){
            if(!fo[i].dead){
                Image ima=fo[i].move(loa,two);
                h.drawImage(ima,100+(int)fo[i].x,100+(int)fo[i].y-40,this);
                int ma=(int)(Math.random()*100);
                int mb=(int)(Math.random()*100);
                int mc=(int)(Math.random()*10);
                int md=(int)(Math.random()*10);
                if(mc==0&&ma<fo[i].sprung){
                    fo[i].startjump();
                }
                if(md==0&&mb<fo[i].baller){
                    loa.createKugel(false,fo[i].x+20,fo[i].y-20,fo[i].xdrift*2,0);
                }
                if(two){
                    if(loa.player2.x+20>=fo[i].x&&loa.player2.x+20<fo[i].x+40){
                        if(loa.player2.y-20>=fo[i].y-40&&loa.player2.y-20<fo[i].y){
                            player2.loose();
                        }
                    }
                }
                else{
                    if(loa.player1.x+20>=fo[i].x&&loa.player1.x+20<fo[i].x+40){
                        if(loa.player1.y-20>=fo[i].y-40&&loa.player1.y-20<fo[i].y){
                            player1.loose();
                        }
                    }
                }
                for(int j=0;j<200;j++){
                    if(kugel[j]!=null&&!kugel[j].off&&kugel[j].yours){
                        if(kugel[j].x>=fo[i].x&&kugel[j].x<fo[i].x+40&&kugel[j].y<fo[i].y&&kugel[j].y>=fo[i].y-40){
                            fo[i].dead=true;
                        }
                    }
                }
            }
        }
        for(int i=0;i<200;i++){
            if(kugel[i]!=null&&!kugel[i].off){
                kugel[i].move(two);
                kugel[i].stone(loa);
                h.setColor(Color.blue);
                h.fillOval(100+(int)kugel[i].x-3,100+(int)kugel[i].y-3,6,6);
                if(!kugel[i].yours&&two){
                    if(kugel[i].x>=loa.player2.x&&kugel[i].x<loa.player2.x+40&&kugel[i].y<loa.player2.y&&kugel[i].y>=loa.player2.y-40){
                        player2.loose();
                        kugel[i].off=true;
                    }
                }
                if(!kugel[i].yours&&!two){
                    if(kugel[i].x>=loa.player1.x&&kugel[i].x<loa.player1.x+40&&kugel[i].y<loa.player1.y&&kugel[i].y>=loa.player1.y-40){
                        player1.loose();
                        kugel[i].off=true;
                    }
                }
            }
        }
//        if(!two){
           Image pim1=loa.player1.move(loa,two);
           Image pim2=loa.player2.move(loa,two);
//        }
//        else{
//            Image abort1=loa.player1.move(loa,two);
//            Image abort2=loa.player2.move(loa,two);
//        }
        h.drawImage(pim1,100+(int)loa.player1.x,100+(int)loa.player1.y-40,this);
        h.drawImage(pim2,100+(int)loa.player2.x,100+(int)loa.player2.y-40,this);
        h.setColor(Color.red);
        h.drawString(info,100+xpos-width/3,100+ypos-height/3);
        g.setColor(Color.white);
        g.fillRect(0,0,800,600);
        g.drawImage(img,-100-xpos+width/2,-100-ypos+height/2,this);
//        paint(g);
    }
}
class Kugel{
    double x;
    double y;
    double xdrift;
    double ydrift;
    int cur;
    boolean yours=false;
    boolean off=false;
    public Kugel(boolean yours,double x,double y,double xdrift,double ydrift){
        this.yours=yours;
        this.x=x;
        this.y=y;
        this.xdrift=xdrift;
        this.ydrift=ydrift;
        cur=0;
    }
    public void stone(Loadera loa){
        int xl=loa.xl;
        int yl=loa.yl;
        int[][]backgr=loa.backgr;
        int xj=(int)x/40;
        int yj=(int)y/40;
        if(xj>=0&&x>=0&&yj>=0&&y>=0&&xj<xl&&yj<yl){
            if(backgr[xj][yj]==1){
                off=true;
            }
        }
        if(x<0||y<0||xj>=xl||yj>=yl){
            off=true;
        }
    }
    public void move(boolean two){
        if(two){
            return;
        }
        if(off){
            return;
        }
        x=x+xdrift;
        y=y+ydrift;
        cur++;
        if(cur==40){
            off=true;
        }
    }
}
class JumpObject{
    String source;
    Image pic;
    double points;
    int lifes;
    double faster;
    double gunadd;
    int x;
    int y;
    int pos=0;
    boolean off=false;
    public JumpObject(String source){
        this.source=source;
        load();
    }
    public JumpObject(){
    }
    public void load(){
        try{
            InputStream fis=AstroJump.getInputStream(source);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String a=dis.readLine();
            String imn=dis.readLine();
            points=new Double(dis.readLine()).doubleValue();
            lifes=new Integer(dis.readLine()).intValue();
            faster=new Double(dis.readLine()).doubleValue();
            gunadd=new Double(dis.readLine()).doubleValue();
            fis.close();
            Frame f=new Frame();
            pic=AstroJump.getImage(imn);
            AstroJump.app2.tracker.addImage(pic,0);
        }
        catch(Exception e){
            System.out.println("object load error: "+e);
        }
    }
    public JumpObject cloneo(){
        JumpObject ret=new JumpObject();
        ret.pic=pic;
        ret.points=points;
        ret.lifes=lifes;
        ret.faster=faster;
        ret.gunadd=gunadd;
        return ret;
    }
}
class FigureObject{
    double speed;
    double sprung;
    double baller;
    Image[]running;
    Image[]jumpup;
    Image[]jumpdown;
    String source;
    double xs;
    double ys;
    double x;
    double y;
    int cur;
    int curup;
    int curdown;
    double t=0;
    double jstartx;
    double jstarty;
    double xdrift;
    double ydrift;
    double lx;
    double ly;
    double lastdriftx=0;
    double lastdrifty=0;
    boolean canjump=false;
    boolean jumpb=false;
    boolean jumpupb=false;
    boolean jumpdownb=false;
    boolean dead=false;
    boolean player;
    int lifes=3;
    double points=0;
    double faster=0;
    double gunadd=0;
    int oldindex=0;
    int oldart=0;
    int curindex=0;
    int curart=0;
    public FigureObject(String source){
        this.source=source;
        load();
    }
    public FigureObject(){
    }
    public void loose(){
        lifes--;
        x=xs;
        y=ys;
        xdrift=0;
        ydrift=0;
        jumpb=false;
    }
    public void startjump(){
        if(canjump){
            cur=0;
            curup=0;
            curdown=0;
            y=y-1;
            jstartx=x;
            jstarty=y;
            lx=jstartx;
            ly=jstarty;
            ydrift=-20;
            t=0;
            jumpb=true;
            jumpupb=true;
        }
    }
    public Image move(Loadera loa,boolean two){
        double xo=x;
        Image ret=null;
        int[][]backgr=loa.backgr;
        int xl=loa.xl;
        int yl=loa.yl;
        if(x<0){
            x=xl*40+x;
        }
        if(x>xl*40){
            x=x-xl*40;
        }
        if(lx<0){
            lx=xl*40+lx;
        }
        if(lx>xl*40){
            lx=lx-xl*40;
        }
//+20 added on 27.03.2023
        int xj=(int)(x+20)/40;
        int yj=(int)y/40;
        if(yj>=yl){
//            dead=true;
            y=0;
            ly=0;
        }
        else{
            if(xj>=0&&x>=0&&xj<xl&&yj>=0){
                int val=backgr[xj][yj];
                if(val==1){
                    jumpb=false;
                    jumpupb=false;
                    jumpdownb=false;
                    canjump=true;
                    curup=0;
                    curdown=0;
                    ydrift=0;
                    y=yj*40;
                }
                else if((val==0||val==2||val==3)&&!jumpb){
                    ret=jumpdown[jumpdown.length-1];
                    curindex=jumpdown.length-1;
                    curart=2;
                    ydrift=ydrift+0.25;
                    canjump=false;
                }
                else{
                    canjump=false;
                }
            }
            else{
                canjump=false;
            }
        }
        if(!jumpb){
            if(!two){
                x=x+xdrift*(faster+1)*0.25;
                y=y+ydrift*(faster+1)*0.25;
            }
            if(xdrift>0){
                int xa=(int)x/40+1;
                int ya=(int)y/40-1;
                if(xa>=0&&x>0&&ya>=0&&y>0&&xa<xl&&ya<yl){
                    if(backgr[xa][ya]==1){
                        xdrift=-xdrift;
                    }
                }
            }
            if(xdrift<0){
                int xa=(int)x/40-1;
                int ya=(int)y/40-1;
                if(xa>=0&&x>0&&ya>=0&&y>0&&xa<xl&&ya<yl){
                    if(backgr[xa][ya]==1){
                        xdrift=-xdrift;
                    }
                }
            }
            lastdrifty=ydrift;
            ret=running[cur];
            curindex=cur;
            curart=0;
            if(!two){
                cur=(cur+1)%(running.length);
            }
        }
        else{
            if(jumpupb){
                if(!two){
                    lx=lx+xdrift*0.25*(faster+1);
                    ly=ly+ydrift*0.25*(faster+1)+(2.0*(t+0.25)*(t+0.25)-2.0*t*t);
                    t=t+0.25;
                }
                x=(int)lx;
                y=(int)ly;
                if(xdrift>=0){
                    if(curup<jumpup.length){
                        ret=jumpup[curup];
                        curindex=curup;
                        curart=1;
                    }
                    else{
                        ret=jumpup[jumpup.length-1];
                        curindex=jumpup.length-1;
                        curart=1;
                    }
                    if(!two){
                        curup=(curup+1)%jumpup.length;
                    }
                }
                else{
                    if(curdown<jumpdown.length){
                        ret=jumpdown[curdown];
                        curindex=curdown;
                        curart=2;
                    }
                    else{
                        ret=jumpdown[jumpdown.length-1];
                        curindex=jumpdown.length-1;
                        curart=2;
                    }
                    if(!two){
                        curdown=(curdown+1)%jumpdown.length;
                    }
                }
                if(ydrift*0.25*(faster+1)+(2.0*(t+0.25)*(t+0.25)-2.0*t*t)>0){
                    jumpupb=false;
                    jumpdownb=true;
                    curup=0;
                    curdown=0;
                }
            }
            if(jumpdownb){
                if(!two){
                    lx=lx+xdrift*0.25*(faster+1);
                    ly=ly+ydrift*(faster+1)*0.25+(2.0*(t+0.25)*(t+0.25)-2.0*t*t);
                    t=t+0.25;
                }
                x=(int)lx;
                y=(int)ly;
                if(xdrift>=0){
                    if(curdown<jumpdown.length){
                        ret=jumpdown[curdown];
                        curindex=curdown;
                        curart=2;
                    }
                    else{
                        ret=jumpdown[jumpdown.length-1];
                        curindex=jumpdown.length-1;
                        curart=2;
                    }
                    if(!two){
                        curdown=(curdown+1)%jumpdown.length;
                    }
                }
                else{
                    if(curup<jumpup.length){
                        ret=jumpup[curup];
                        curindex=curup;
                        curart=1;
                    }
                    else{
                        ret=jumpup[jumpup.length-1];
                        curindex=jumpup.length-1;
                        curart=1;
                    }
                    if(!two){
                        curup=(curup+1)%jumpup.length;
                    }
                }
            }
        }
        Kugel[]kugel=loa.kugel;
        for(int i=0;false&&i<200;i++){
            if(kugel[i]!=null&&!kugel[i].off){
                if(kugel[i].x>=x&&kugel[i].x>=x+40&&kugel[i].y>=y-40&&kugel[i].y<y){
                    if(kugel[i].yours==player){
                        dead=true;
                        kugel[i].off=true;
                    }
                }
            }
        }
        if(x==xo&&!jumpb){
            curindex=0;
            curart=0;
            ret=running[0];
        }
        if(two){
            if(oldart==0){
                ret=running[oldindex];
            }
            else if(oldart==1){
                ret=jumpup[oldindex];
            }
            else if(oldart==2){
                ret=jumpdown[oldindex];
            }
        }
        oldindex=curindex;
        oldart=curart;
        return ret;
    }
    public void load(){
        try{
            InputStream fis=AstroJump.getInputStream(source);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String s=dis.readLine();
            speed=new Double(dis.readLine()).doubleValue();
            sprung=new Double(dis.readLine()).doubleValue();
            baller=new Double(dis.readLine()).doubleValue();
            Frame f=new Frame();
            int n=new Integer(dis.readLine()).intValue();
            running=new Image[n];
            for(int i=0;i<n;i++){
                running[i]=AstroJump.getImage(dis.readLine());
                AstroJump.app2.tracker.addImage(running[i],0);
            }
            n=new Integer(dis.readLine()).intValue();
            jumpup=new Image[n];
            for(int i=0;i<n;i++){
                jumpup[i]=AstroJump.getImage(dis.readLine());
                AstroJump.app2.tracker.addImage(jumpup[i],0);
            }
            n=new Integer(dis.readLine()).intValue();
            jumpdown=new Image[n];
            for(int i=0;i<n;i++){
                jumpdown[i]=AstroJump.getImage(dis.readLine());
                AstroJump.app2.tracker.addImage(jumpdown[i],0);
            }
            fis.close();
        }
        catch(Exception e){
            System.out.println("figure load error: "+e);
        }
    }
    public FigureObject cloneo(){
        FigureObject ret=new FigureObject();
        ret.speed=speed;
        ret.sprung=sprung;
        ret.baller=baller;
        ret.running=running;
        ret.jumpup=jumpup;
        ret.jumpdown=jumpdown;
        return ret;
    }
}
class StringHolder{
    String[]s=new String[0];
    public boolean contained(String str){
        int n=s.length;
        for(int i=0;i<n;i++){
            if(str.equals(s[i])){
                return true;
            }
        }
        return false;
    }
    public void add(String str){
        if(contained(str)){
        }
        else{
            int n=s.length;
            String[]s2=new String[n+1];
            for(int i=0;i<n;i++){
                s2[i]=s[i];
            }
            s2[n]=str;
            s=s2;
        }
    }
}
class StringPair{
    String[]s=new String[0];
    Object[]o=new Object[0];
    public boolean contained(String str){
        int n=s.length;
        for(int i=0;i<n;i++){
            if(str.equals(s[i])){
                return true;
            }
        }
        return false;
    }
    public void add(String str,Object obj){
        if(contained(str)){
        }
        else{
            int n=s.length;
            String[]s2=new String[n+1];
            Object[]o2=new Object[n+1];
            for(int i=0;i<n;i++){
                s2[i]=s[i];
                o2[i]=o[i];
            }
            s2[n]=str;
            o2[n]=obj;
            s=s2;
            o=o2;
        }
    }
    public Object getObj(String str){
        int n=s.length;
        for(int i=0;i<n;i++){
            if(str.equals(s[i])){
                return o[i];
            }
        }
        return null;
    }
}
class ImFrameAppl extends JFrame{
    Image img;
    private static final long serialVersionUID = -6808800089032555784L;
    public ImFrameAppl(int xl,int yl){
        pack();
        img=createImage(xl*40+200,yl*40+200);
    }
}
class KeyboardMapperAppletSwing extends JPanel implements ActionListener,KeyListener,MouseListener{
    JLabel info;
    ListBox l;
    JButton remove;
    JButton addspecial;
    JButton apply;
    JButton cancel;
    JButton dontapply;
    boolean cancelb=false;
    boolean applyb=false;
    boolean closed=false;
    int kstatus=0;
    int aliasx=0;
    KeyMapperTable kmt;
    JApplet applet;
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    private static final long serialVersionUID = 5772434866526097156L;
    public KeyboardMapperAppletSwing(JApplet applet){
        setSize(400,400);
        setLayout(null);
        this.applet=applet;
        info=new JLabel("");
        l=new ListBox();
        remove=new JButton("remove");
        addspecial=new JButton("add special key");
        apply=new JButton("apply");
        cancel=new JButton("cancel");
        dontapply=new JButton("don't apply");
        add(info);
        add(l);
        add(remove);
        add(addspecial);
        add(apply);
        add(cancel);
        add(dontapply);
        info.setBounds(10,10,380,27);
        l.setBounds(10,40,380,170);
        remove.setBounds(10,250,80,27);
        addspecial.setBounds(10,280,380,27);
        apply.setBounds(10,310,80,27);
        cancel.setBounds(210,310,80,27);
        dontapply.setBounds(10,340,160,27);
        kmt=new KeyMapperTable();
        loadfirst();
        savekmt();
        remove.addActionListener(this);
        addspecial.addActionListener(this);
        apply.addActionListener(this);
        cancel.addActionListener(this);
        dontapply.addActionListener(this);
        addKeyListener(this);
        addMouseListener(this);
        info.setOpaque(true);
        info.setBackground(Color.white);
    }
    public InputStream getInputStream(String filename){
        try{
            InputStream is=applet.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
        }
        return null;
    }
    public synchronized void mousePressed(MouseEvent me) {
        requestFocus();
        l.click(me.getX()-10,me.getY()-40);
        l.repaint();
    }
    public synchronized void mouseReleased(MouseEvent e) {
    }
    public synchronized void mouseExited(MouseEvent e) {
    }
    public synchronized void mouseEntered(MouseEvent e) {
    }
    public synchronized void mouseClicked(MouseEvent e) {
    }
    public int getKeyCode(int a){
        int n=alias.length;
        for(int i=0;i<n;i++){
            if(alias[i]==a){
                return key[i];
            }
        }
        return a;
    }
    public void savekmt(){
        alias=kmt.alias;
        key=kmt.key;
        special=kmt.special;
    }
    public void restorekmt(){
        kmt.alias=alias;
        kmt.key=key;
        kmt.special=special;
        l.reset();
        int n=key.length;
        for(int i=0;i<n;i++){
            l.addElement("special key "+alias[i]+" alias for "+key[i]);
        }
        l.repaint();
    }
    public void loadfirst(){
        try{
            FileInputStream fis=new FileInputStream("keymapforus.ini");
            fis.close();
            load("keymapforus.ini");
            info.setText("keymapforus.ini loaded and not applied");
        }
        catch(Exception e){
        }
    }
    public void load(String filename){
        try{
            FileInputStream fis=new FileInputStream(filename);
            BufferedReader dis=new BufferedReader(new InputStreamReader(fis));
            String inp=null;
            while((inp=dis.readLine())!=null){
                String inp2=dis.readLine();
                String inp3=dis.readLine();
                kmt.addspecial(inp,inp2);
            }
            dis.close();
            fis.close();
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            int n=alias.length;
            for(int i=0;i<n;i++){
                l.addElement("special key "+alias[i]+" alias for "+key[i]);
            }
            l.repaint();
        }
        catch(Exception e){
            info.setText("File not found: "+filename);
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public synchronized void keyPressed(KeyEvent e){
        requestFocus();
        int ekey=e.getKeyCode();
        if(kstatus==1){
            aliasx=ekey;
            kstatus=2;
            info.setText("type key");
        }
        else if(kstatus==2){
            int keyx=ekey;
            kstatus=0;
            info.setText("special key added");
            info.setBackground(Color.white);
            kmt.addspecial(""+aliasx,""+keyx);
            l.addElement("special key "+aliasx+" alias for "+keyx);
            l.repaint();
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==remove){
            int ind=l.getSelectedIndex();
            if(ind!=-1){
                l.removeElementAt(ind);
                kmt.remove(ind);
                l.repaint();
            }
        }
        if(evt.getSource()==addspecial){
            info.setText("type alias");
            kstatus=1;
            info.setBackground(Color.yellow);
            requestFocus();
        }
        if(evt.getSource()==apply){
            alias=kmt.alias;
            key=kmt.key;
            special=kmt.special;
            applyb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==cancel){
            restorekmt();
            cancelb=true;
            closed=true;
            setVisible(false);
        }
        if(evt.getSource()==dontapply){
            applyb=false;
            info.setText("KeyboardMapper isn't applied");
        }
    }
}
class KeyMapperTable{
    int[]alias=new int[0];
    int[]key=new int[0];
    boolean[]special=new boolean[0];
    public KeyMapperTable(){
    }
    public void reset(){
        alias=new int[0];
        key=new int[0];
        special=new boolean[0];
    }
    public void addspecial(String a,String b){
        int n=alias.length;
        int[]aliasb=new int[n+1];
        int[]keyb=new int[n+1];
        boolean[]specialb=new boolean[n+1];
        for(int i=0;i<n;i++){
            aliasb[i]=alias[i];
            keyb[i]=key[i];
            specialb[i]=special[i];
        }
        try{
            aliasb[n]=new Integer(a).intValue();
            keyb[n]=new Integer(b).intValue();
        }
        catch(Exception exc){
        }
        specialb[n]=true;
        alias=aliasb;
        key=keyb;
        special=specialb;
    }
    public void remove(int ind){
        int n=alias.length;
        if(n>0){
            int[]aliasb=new int[n-1];
            int[]keyb=new int[n-1];
            boolean[]specialb=new boolean[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind){
                }
                else{
                    aliasb[ib]=alias[i];
                    keyb[ib]=key[i];
                    specialb[ib]=special[i];
                    ib=ib+1;
                }
            }
            alias=aliasb;
            key=keyb;
            special=specialb;
        }
    }
}
class ListBox extends JPanel{
    String[]thestrings=new String[0];
    GetImgKeyboardMapper gikm;
    Image img;
    int uppest=0;
    int n=0;
    int ind=-1;
    private static final long serialVersionUID = -457533304480165971L;
    public ListBox(){
        setLayout(null);
        gikm=new GetImgKeyboardMapper();
        img=gikm.img;
        repaint();
    }
    public synchronized void reset(){
        thestrings=new String[0];
        n=0;
        uppest=0;
        ind=-1;
    }
    public synchronized void setListData(String[]str){
        thestrings=str;
        n=thestrings.length;
    }
    public synchronized void addElement(String s){
        String[]thestrings2=new String[n+1];
        for(int i=0;i<n;i++){
            thestrings2[i]=thestrings[i];
        }
        thestrings2[n]=s;
        n=n+1;
        thestrings=thestrings2;
        uppest=n-8;
        if(uppest<0){
            uppest=0;
        }
    }
    public synchronized void removeElementAt(int ind2){
        int n=thestrings.length;
        if(n>0){
            if(ind==ind2){
                ind=-1;
            }
            else if(ind>ind2){
                ind=ind-1;
            }
            String[]thestrings2=new String[n-1];
            int ib=0;
            for(int i=0;i<n;i++){
                if(i==ind2){
                }
                else{
                    thestrings2[ib]=thestrings[i];
                    ib=ib+1;
                }
            }
            thestrings=thestrings2;
            this.n=n-1;
            if(uppest+8>=n){
                uppest=uppest-1;
                if(uppest<0){
                    uppest=0;
                }
            }
        }
    }
    public synchronized int getSelectedIndex(){
        return ind;
    }
    public synchronized void click(int x,int y){
        if(x>=10&&x<370&&y>=5&&y<5+16){
            uppest=uppest-1;
            if(uppest<0){
                uppest=0;
            }
        }
        if(x>=10&&x<370&&y>=5+9*16&&y<5+9*16+16){
            uppest=uppest+1;
            if(uppest+8>n){
                uppest=uppest-1;
            }
        }
        if(x>=10&&x<370&&y>=5+16&&y<5+8*16+16){
            int ind2=(y-5-16)/16+uppest;
            if(ind2>=0&&ind2<n){
                ind=ind2;
            }
        }
    }
    public synchronized void paint(Graphics g){
        Graphics h=img.getGraphics();
        h.setColor(Color.white);
        h.fillRect(0,0,380,170);
        h.setColor(Color.black);
        for(int i=0;i<10;i++){
            h.setColor(Color.black);
            if(ind==uppest+i-1&&ind!=-1&&i!=0&&i!=9){
                h.setColor(Color.green);
            }
            h.drawRect(10,5+i*16,360,15);
        }
        h.setColor(Color.black);
        if(uppest==0){
            h.setColor(Color.red);
        }
        h.drawString("UP",12,5+14);
        h.setColor(Color.black);
        if(uppest+8>=n){
            h.setColor(Color.red);
        }
        h.drawString("DOWN",12,5+9*16+14);
        h.setColor(Color.black);
        for(int i=0;i<8;i++){
            h.setColor(Color.black);
            if(ind==uppest+i&&ind!=-1){
                h.setColor(Color.green);
            }
            int theindex=uppest+i;
            if(theindex<n){
                h.drawString(thestrings[theindex],12,5+16+i*16+14);
            }
        }
        g.drawImage(img,0,0,this);
    }
}
class GetImgKeyboardMapper extends JFrame{
    Image img;
    private static final long serialVersionUID = -8478639040178665797L;
    public GetImgKeyboardMapper(){
        pack();
        img=createImage(380,170);
    }
}
