import java.io.*;
import java.awt.*;
import java.applet.*;
import java.net.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;
public class OpenLevelXarrow3D extends JApplet implements Runnable,KeyListener,ActionListener{
    Vector<String> lcontent;
    JList<String> l;
    JScrollPane spl;
    Thread t;
    JButton b;
    boolean startb=false;
    static JApplet app;
    static OpenLevelXarrow3D app2;
    JPanel p1;
    Xarrow3D xarrow;
    JLabel la;
    private static final long serialVersionUID = 7922336267791755533L;
    public void init(){
        app=this;
        app2=this;
        setSize(400,440);
        setLayout(null);
        la=new JLabel("Xarrow3D");
        add(la);
        la.setBounds(10,10,200,27);
        lcontent=new Vector<String>();
        l=new JList<String>(lcontent);
        spl=new JScrollPane(l);
        b=new JButton("open");
        p1=new JPanel();
        p1.setLayout(null);
        add(p1);
        p1.setBounds(0,40,400,400);
        p1.add(spl);
        p1.add(b);
        spl.setBounds(10,40,380,300);
        b.setBounds(10,350,380,27);
        b.addActionListener(this);
        setVisible(true);
        readLevelList();
        setFocusable(true);
        requestFocus();
        addKeyListener(this);
        t=new Thread(this);
        t.start();
    }
    public void run(){
        while(true){
            try{
                repaint();
                Thread.sleep(100);
                if(startb){
                    startb=false;
                    int ind=l.getSelectedIndex();
                    if(ind!=-1&&ind<lcontent.size()){
                        String levstring=lcontent.elementAt(ind);
                        la.setText("Xarrow3D: "+levstring);
                        p1.setVisible(false);
                        xarrow=new Xarrow3D(this,levstring);
                        add(xarrow);
                        xarrow.setBounds(0,0,400,440);
                    }
                }
            }
            catch(Exception e){
            }
        }
    }
    public static InputStream getInputStream(String filename){
        try{
            InputStream is=app.getClass().getResourceAsStream("/"+filename);
            return is;
        }
        catch(Exception e){
            e.printStackTrace(System.out);
        }
        return null;
    }
    public static Image getImage(String filename){
        try{
            URL url=app.getClass().getResource("/"+filename);
            Image img=app.getToolkit().getImage(url);
            return img;
        }
        catch(Exception e){
        }
        return null;
    }
    public void actionPerformed(ActionEvent evt){
        if(evt.getSource()==b){
            startb=true;
        }
    }
    public void keyTyped(KeyEvent e){
    }
    public void keyPressed(KeyEvent e){
        if(xarrow!=null){
            xarrow.process(e);
        }
    }
    public void keyReleased(KeyEvent e){
    }
    public void readLevelList(){
        try{
            InputStream is=OpenLevelXarrow3D.getInputStream("levs.ini");
            BufferedReader dis=new BufferedReader(new InputStreamReader(is));
            String news="";
            while((news=dis.readLine())!=null){
                lcontent.addElement(news);
            }
            is.close();
            l.setListData(lcontent);
        }
        catch(Exception e){};
    }
}
class Xarrow3D extends JPanel implements Runnable{
    Thread t;
    int xpos=0;
    int ypos=0;
    int xdrift=0;
    int ydrift=0;
    String name;
    int[][]screen;
    Group[][]groupscreen;
    Group[][]groupscreenb;
    Group player;
    int width=0;
    int height=0;
    int lifes=3;
    int points=0;
    int treasures=0;
    int xstart=0;
    int ystart=0;
    boolean wall=true;
    boolean inverse=false;
    boolean moveplayer=true;
    double alpha=Math.PI/2;
    double beta=Math.PI/4;
    Vektor camerapos;
    Vektor cameraposplus;
    EngineXarrow3D eng;
    OpenLevelXarrow3D ol;
    boolean endfirst=true;
    boolean running=true;
    Color pcolor;
    Color pcolor2;
    int turbo=0;
    int drive=0;
    int direction=0;
    int turbob=0;
    int driveb=0;
    int directionb=0;
    int phase=4;
    boolean all=false;
    boolean seldir=false;
    boolean eup=false;
    boolean edown=false;
    boolean eleft=false;
    boolean eright=false;
    boolean edelete=false;
    boolean startd=true;
    int ax=0;
    int ay=0;
    int xw=0;
    int yw=0;
    int winstatus=0;
    int keycode=0;
    private static final long serialVersionUID = 7843182638816753926L;
    public Xarrow3D(OpenLevelXarrow3D ol,String name){
//        super("Astro Solutions Xarrow3D");
        setSize(400,440);
        setLayout(null);
        this.ol=ol;
        pcolor=new Color(255,255,0);
        pcolor2=new Color(255,0,0);
        eng=new EngineXarrow3D();
        eng.setStatus("");
        add(eng);
        eng.setBounds(0,40,400,400);
        setVisible(true);
        this.name=name;
        screen=new int[30][18];
        groupscreen=new Group[30][18];
        groupscreenb=new Group[30][18];
        player=ObjectGenerator.getKugel();
        loadScreen();
        build();
        t=new Thread(this);
        t.start();
    }
    public void setWallOn(){
        wall=true;
    }
    public void setWallOff(){
        wall=false;
    }
    public void loadScreen(){
        try{
            InputStream is=OpenLevelXarrow3D.getInputStream(name);
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    screen[i][j]=is.read();
//System.out.println("i: "+i+" j: "+j+" screen: "+screen[i][j]);
                    if(screen[i][j]==12){
                        treasures++;
                    }
                    if(screen[i][j]==13){
                        xpos=i*50;
                        ypos=j*50;
                        xstart=xpos;
                        ystart=ypos;
                        camerapos=new Vektor(xpos+25,ypos+25,300);
                        cameraposplus=new Vektor(-Math.cos(alpha)*300,-Math.sin(alpha)*300,0);
                        player.transform(xpos,ypos,0);
                        eng.add(player);
                        screen[i][j]=0;
                    }
                }
            }
        }
        catch(Exception e){
        }
    }
    public void run(){
        int gc=0;
        while(running){
//            try{
                int xw=200;
                int yw=200;
                Dimension d=getSize();
                xw=d.width;
                yw=d.height;
                if(xw!=ax||yw!=ay){
                    ax=xw;
                    ay=yw;
                    eng.setBounds(0,40,ax,ay-40);
                }
                if(keycode!=0){
                    process(keycode);
                }
                keycode=0;
//System.out.println("xxx"+Runtime.getRuntime().freeMemory());
                action();
                step();
//System.out.println("yyy");
                if(gc>=100){
                    gc=0;
                    System.gc();
                }
                gc=gc+1;
//System.out.println("yyy");
                cameraposplus.x=Math.cos(alpha)*300;
                cameraposplus.y=Math.sin(alpha)*300;
                double xtrans=camerapos.x+cameraposplus.x;
                double ytrans=camerapos.y+cameraposplus.y;
                double ztrans=camerapos.z+cameraposplus.z;
                double alphab=alpha;
                double betab=beta;
                setWallOn();
//System.out.println("transform");
                eng.transform(-xtrans,-ytrans,-ztrans);
//System.out.println("xtrans: "+xtrans);
//System.out.println("ytrans: "+ytrans);
//System.out.println("ztrans: "+ztrans);
//System.out.println("alphab: "+alphab);
//System.out.println("betab: "+betab);
                alphab=alphab+Math.PI;
                if(alphab>2*Math.PI){
                    alphab=alphab-2*Math.PI;
                }
                eng.rotLeft(-alphab);
                eng.rotUp(betab);
//System.out.println("gs: "+groupscreen[0][0].start.start.x);
                eng.setOn();
                eng.move();
                eng.repaint();
try{
                Thread.sleep(80);
}
catch(Exception e){
}
                eng.setOff();
                eng.rotUp(-betab);
                eng.rotLeft(alphab);
                eng.transform(xtrans,ytrans,ztrans);
                setWallOff();
//            }
//            catch(Exception e){
//                System.out.println("e: "+e);
//                try{
//                    Thread.sleep(10000);
//                }
//                catch(Exception eb){
//                };
//            }
        }
    }
    public void action(){
            if(edown){
                edown=false;
                if(moveplayer){
//System.out.println("a");
                    if(!seldir){
                        keyPressed(-4);
                    }
                    else{
                        xdrift=0;
                        ydrift=5;
                    }
                }
                else{
//System.out.println("b");
                    if(!inverse&&beta+Math.PI/90<=Math.PI/2){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else if(beta-Math.PI/90>=-Math.PI/2){
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(eup){
                eup=false;
                if(moveplayer){
                    if(!seldir){
                        keyPressed(-3);
                    }
                    else{
                        xdrift=0;
                        ydrift=-5;
                    }
                }
                else{
                    if(inverse&&beta+Math.PI/90<=Math.PI/2){
                        beta=beta+Math.PI/90;
                        if(beta>Math.PI/2){
                            beta=Math.PI/2-Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=true;
                            eng.setInverseOn();
                        }
                    }
                    else if(beta-Math.PI/90>=-Math.PI/2){
                        beta=beta-Math.PI/90;
                        if(beta<-Math.PI/2){
                            beta=-Math.PI/2+Math.PI/90;
                            alpha=alpha+Math.PI;
                            if(alpha>2*Math.PI){
                                alpha=alpha-2*Math.PI;
                            }
                            inverse=false;
                            eng.setInverseOff();
                        }
                    }
                }
            }
            if(eright){
                eright=false;
                if(moveplayer){
                   if(!seldir){
                       keyPressed(-1);
                   }
                   else{
                       xdrift=5;
                       ydrift=0;
                   }
                }
                else{
                    alpha=alpha-Math.PI/90;
                    if(alpha<0){
                        alpha=alpha+2*Math.PI;
                    }
                }
            }
            if(eleft){
                eleft=false;
                if(moveplayer){
                    if(!seldir){
                        keyPressed(-2);
                    }
                    else{
                        xdrift=-5;
                        ydrift=0;
                    }
                }
                else{
                    alpha=alpha+Math.PI/90;
                    if(alpha>2*Math.PI){
                        alpha=alpha-2*Math.PI;
                    }
                }
            }
            if(edelete){
                edelete=false;
                if(moveplayer){
                    moveplayer=false;
                }
                else{
                    moveplayer=true;
                }
            }

    }
    public void process(KeyEvent evt){
        keycode=evt.getKeyCode();
    }
    public void process(int key){
            if(key==27||key==KeyEvent.VK_ESCAPE){
                setVisible(false);
                running=false;
                OpenLevelXarrow3D.app2.p1.setVisible(true);
            }
            if(key==KeyEvent.VK_DOWN){
                if(startd){
                    xdrift=0;
                    ydrift=5;
                    startd=false;
                }
                else{
                    edown=true;
                }
            }
            if(key==KeyEvent.VK_UP){
                if(startd){
                    xdrift=0;
                    ydrift=-5;
                    startd=false;
                }
                else{
                    eup=true;
                }
            }
            if(key==KeyEvent.VK_RIGHT){
                if(startd){
                    xdrift=5;
                    ydrift=0;
                    startd=false;
                }
                else{
                    eright=true;
                }
            }
            if(key==KeyEvent.VK_LEFT){
                if(startd){
                    xdrift=-5;
                    ydrift=0;
                    startd=false;
                }
                else{
                    eleft=true;
                }
            }
            if(key==KeyEvent.VK_DELETE){
                edelete=true;
            }
    }
    public void keyPressed(int keycode){
        if(keycode==-1){
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    if(screen[i][j]>=1&&screen[i][j]<=4){
                        groupscreen[i][j].transform(-i*50-25,-j*50-25,0);
                        groupscreen[i][j].rotLeft(Math.PI/2);
                        groupscreen[i][j].transform(i*50+25,j*50+25,0);
                        screen[i][j]=screen[i][j]-1;
                        if(screen[i][j]==0){
                            screen[i][j]=4;
                        }
                    }
                }
            }
        }
        if(keycode==-2){
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    if(screen[i][j]>=1&&screen[i][j]<=4){
                        groupscreen[i][j].transform(-i*50-25,-j*50-25,0);
                        groupscreen[i][j].rotLeft(-Math.PI/2);
                        groupscreen[i][j].transform(i*50+25,j*50+25,0);
                        screen[i][j]=screen[i][j]+1;
                        if(screen[i][j]==5){
                            screen[i][j]=1;
                        }
                    }
                }
            }
        }
        if(keycode==-3||keycode==-4){
            for(int i=0;i<30;i++){
                for(int j=0;j<18;j++){
                    if(screen[i][j]>=8&&screen[i][j]<=10){
                        eng.remove(groupscreen[i][j]);
                        if(groupscreenb[i][j]!=null){
                            eng.remove(groupscreenb[i][j]);
                            groupscreenb[i][j]=null;
                        }
                        if(keycode==-3){
                            screen[i][j]=screen[i][j]+1;
                            if(screen[i][j]==11){
                                screen[i][j]=8;
                            }
                        }
                        else{
                            screen[i][j]=screen[i][j]-1;
                            if(screen[i][j]==7){
                                screen[i][j]=10;
                            }
                        }
                        if(screen[i][j]==8){
                            groupscreen[i][j]=ObjectGenerator.getLochz();
                            groupscreen[i][j].transform(i*50,j*50,0);
                            eng.add(groupscreen[i][j]);
                        }
                        if(screen[i][j]==9){
                            groupscreen[i][j]=ObjectGenerator.getBodenz();
                            groupscreen[i][j].transform(i*50,j*50,0);
                            eng.add(groupscreen[i][j]);
                        }
                        if(screen[i][j]==10){
                            groupscreen[i][j]=ObjectGenerator.getSteinz();
                            groupscreen[i][j].transform(i*50,j*50,0);
                            eng.add(groupscreen[i][j]);
                            groupscreenb[i][j]=ObjectGenerator.getBoden();
                            groupscreenb[i][j].transform(i*50,j*50,0);
                            eng.add(groupscreenb[i][j]);
                        }


                    }
                }
            }
        }
    }
    public void keyPressedb(int keycode){
        if(keycode==-3){
            double axpos=xpos;
            if(xpos==0){
                xpos=xpos-50;
            }
            if(xpos-50>=0&&screen[(xpos-50)/50][ypos/50]!=1&&screen[(xpos-50)/50][ypos/50]!=2){
                xpos=xpos-50;
            }
            camerapos.x=xpos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(xpos-axpos,0,0);
        }
        if(keycode==-4){
            double axpos=xpos;
            if(xpos==1450){
                xpos=xpos+50;
            }
            if(xpos+50<1500&&screen[(xpos+50)/50][ypos/50]!=1&&screen[(xpos+50)/50][ypos/50]!=2){
                xpos=xpos+50;
            }
            camerapos.x=xpos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(xpos-axpos,0,0);
        }
        if(keycode==-2){
            double aypos=ypos;
            if(ypos==850){
                ypos=ypos+50;
            }
            if(ypos+50<900&&screen[xpos/50][(ypos+50)/50]!=1&&screen[xpos/50][(ypos+50)/50]!=2){
                ypos=ypos+50;
            }
            camerapos.y=ypos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(0,ypos-aypos,0);
        }
        if(keycode==-1){
            double aypos=ypos;
            if(ypos==0){
                ypos=ypos-50;
            }
            if(ypos-50>=0&&screen[xpos/50][(ypos-50)/50]!=1&&screen[xpos/50][(ypos-50)/50]!=2){
                ypos=ypos-50;
            }
            camerapos.y=ypos;
            while(wall){
                try{
                   Thread.yield();
                }
                catch(Exception e){
                }
            }
            player.transform(0,ypos-aypos,0);
        }
        if(keycode==-5){
//            newbomb(xpos/50,ypos/50,true);
        }
        if(keycode==-8){
//            Loader mov=new Loader(m,"game stopped");
//            Display d=Display.getDisplay(m);
//            d.setCurrent((Displayable)mov);
        }
    }
    public void build(){
        for(int i=0;i<32;i++){
            Group rand=ObjectGenerator.getHardStone();
            rand.transform(i*50-50,-50,0);
            eng.add(rand);
            Group randx=ObjectGenerator.getBoden();
            randx.transform(i*50-50,-50,0);
            eng.add(randx);
            Group rand2=ObjectGenerator.getHardStone();
            rand2.transform(i*50-50,900,0);
            eng.add(rand2);
            Group randx2=ObjectGenerator.getBoden();
            randx2.transform(i*50-50,900,0);
            eng.add(randx2);
        }
        for(int i=0;i<18;i++){
            Group rand=ObjectGenerator.getHardStone();
            rand.transform(-50,i*50,0);
            eng.add(rand);
            Group randx=ObjectGenerator.getBoden();
            randx.transform(-50,i*50,0);
            eng.add(randx);
            Group rand2=ObjectGenerator.getHardStone();
            rand2.transform(1500,i*50,0);
            eng.add(rand2);
            Group randx2=ObjectGenerator.getBoden();
            randx2.transform(1500,i*50,0);
            eng.add(randx2);
        }
        for(int i=0;i<30;i++){
            for(int j=0;j<18;j++){
                int x=i;
                int y=j;
                if(x>=0&&y>=0&&x<30&&y<18){
//System.out.println("xp:"+xp+"i:"+i);
                    if(screen[x][y]==0||screen[x][y]==6||screen[x][y]==13){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]>=1&&screen[x][y]<=4){
                        groupscreen[x][y]=ObjectGenerator.getArrow();
                        groupscreen[x][y].transform(-25,-25,0);
                        groupscreen[x][y].rotLeft(-(screen[x][y]-2)*Math.PI/2);
                        groupscreen[x][y].transform(i*50+25,j*50+25,0);
//                        Group groupscreenc=ObjectGenerator.getBoden();
//                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
//                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==5){
                        groupscreen[x][y]=ObjectGenerator.getLoch();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==7){
                        groupscreen[x][y]=ObjectGenerator.getStein();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==8){
                        groupscreen[x][y]=ObjectGenerator.getLochz();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==9){
                        groupscreen[x][y]=ObjectGenerator.getBodenz();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==10){
                        groupscreen[x][y]=ObjectGenerator.getSteinz();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        groupscreenb[x][y]=ObjectGenerator.getBoden();
                        groupscreenb[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreenb[x][y]);
                    }
                    if(screen[x][y]==11){
                        groupscreen[x][y]=ObjectGenerator.getZufall();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                        eng.add(groupscreenc);
                    }
                    if(screen[x][y]==12){
                        Group groupscreenc=ObjectGenerator.getBoden();
                        groupscreenc.transform(i*50,j*50,0);
                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getFahne();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]==14){
//                        Group groupscreenc=ObjectGenerator.getBoden();
//                        groupscreenc.transform(i*50,j*50,0);
//                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getWahl();
                        groupscreen[x][y].transform(i*50,j*50,0);
                        eng.add(groupscreen[x][y]);
                    }
                    if(screen[x][y]>=15&&screen[x][y]<=18){
//                        Group groupscreenc=ObjectGenerator.getBoden();
//                        groupscreenc.transform(i*50,j*50,-20);
//                        eng.add(groupscreenc);
                        groupscreen[x][y]=ObjectGenerator.getFestArrow();
                        groupscreen[x][y].transform(-25,-25,0);
                        groupscreen[x][y].rotLeft(-(screen[x][y]-16)*Math.PI/2);
                        groupscreen[x][y].transform(i*50+25,j*50+25,0);
                        eng.add(groupscreen[x][y]);
                    }
                }
            }
        }
    }
    public void step(){
        xpos=xpos+xdrift;
        ypos=ypos+ydrift;
        player.transform(xdrift,ydrift,0);
        camerapos.x=xpos;
        camerapos.y=ypos;
//System.out.println("hallo2");
        boolean loso=false;
        int xposb=(xpos+25)/50;
        int yposb=(ypos+25)/50;
        if(winstatus==0&&xposb>=0&&xposb<30&&yposb>=0&&yposb<18){
            if(screen[xposb][yposb]==12){
                screen[xposb][yposb]=0;
                treasures--;
                eng.remove(groupscreen[xposb][yposb]);
            }
            if(screen[xposb][yposb]==7||screen[xposb][yposb]==10){
                ydrift=-ydrift;
                xdrift=-xdrift;
            }
            if(screen[xposb][yposb]==5){
                loso=true;
            }
            if(screen[xposb][yposb]==8){
                loso=true;
            }
            if(screen[xposb][yposb]==11){
                xdrift=(int)(Math.random()*20)-10;
                ydrift=(int)(Math.random()*20)-10;
            }
            if(screen[xposb][yposb]==1||screen[xposb][yposb]==15){
                xdrift=-5;
                ydrift=0;
            }
            if(screen[xposb][yposb]==2||screen[xposb][yposb]==16){
                xdrift=0;
                ydrift=5;
            }
            if(screen[xposb][yposb]==3||screen[xposb][yposb]==17){
                xdrift=5;
                ydrift=0;
            }
            if(screen[xposb][yposb]==4||screen[xposb][yposb]==18){
                xdrift=0;
                ydrift=-5;
            }
            if(screen[xposb][yposb]==14){
                seldir=true;
            }
            else{
                seldir=false;
            }
        }
//System.out.println("hallo3");
//System.out.println("hallo4");
        if(xpos<0||xpos>=1500){
            xdrift=-xdrift;
        }
        if(ypos<-25||ypos>=900-25){
            ydrift=-ydrift;
        }
        if(treasures==0){
            if(winstatus==0){
                OpenLevelXarrow3D.app2.la.setText("You won!");
                winstatus=1;
            }
            if(endfirst){
                endfirst=false;
//                ol.show();
            }
//            eng.setStatus("You won!");
//            Loader mov=new Loader(m,"You won!");
//            Display d=Display.getDisplay(m);
//            d.setCurrent((Displayable)mov);
        }
        if(loso){
            lifes--;
            if(lifes<=0){
                if(winstatus==0){
                    OpenLevelXarrow3D.app2.la.setText("You lost!");
                    winstatus=2;
                }
//                running=false;
                if(endfirst){
                    endfirst=false;
//                    ol.show();
                }
//                eng.setStatus("You lost!");
//                Loader mov=new Loader(m,"You lost!");
//                Display d=Display.getDisplay(m);
//                d.setCurrent((Displayable)mov);
            }
            else{
                player.transform(xstart-xpos,ystart-ypos,0);
                xpos=xstart;
                ypos=ystart;
                xdrift=0;
                ydrift=0;
                startd=true;
            }
        }
//System.out.println("b");
//        h.drawImage(you,width/2+100,height/2+100,0);
//        g.drawImage(img,-100,-100,0);
    }
}
class ObjectGenerator{
    public static Group getBoden(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.darkGray,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(45,5,0);
        Vektor v7=new Vektor(45,45,0);
        Vektor v8=new Vektor(5,45,0);
        Quad q2=new Quad(Color.lightGray,Color.black,v5,v6,v7,v8);
        Group g=new Group();
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getArrow(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.green,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(20,5,0);
        Vektor v6=new Vektor(20,25,0);
        Vektor v7=new Vektor(5,25,0);
        Vektor v8=new Vektor(25,45,0);
        Vektor v9=new Vektor(45,25,0);
        Vektor v10=new Vektor(30,25,0);
        Vektor v11=new Vektor(30,5,0);
        Polygon p=new Polygon(Color.red,Color.black);
        p.add(v5);
        p.add(v6);
        p.add(v7);
        p.add(v8);
        p.add(v9);
        p.add(v10);
        p.add(v11);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        p.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(p);
        return g;
    }
    public static Group getLoch(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.black,Color.black,v1,v2,v3,v4);
        Group g=new Group();
        g.add(q1);
        return g;
    }
    public static Group getStein(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(45,5,0);
        Vektor v3=new Vektor(45,45,0);
        Vektor v4=new Vektor(5,45,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,30);
        Vektor v6=new Vektor(45,5,30);
        Vektor v7=new Vektor(45,45,30);
        Vektor v8=new Vektor(5,45,30);
        Quad q2=new Quad(Color.blue,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,30);
        Vektor v10=new Vektor(45,5,30);
        Vektor v11=new Vektor(45,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,45,30);
        Vektor v14=new Vektor(45,45,30);
        Vektor v15=new Vektor(45,45,0);
        Vektor v16=new Vektor(5,45,0);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,30);
        Vektor v18=new Vektor(5,45,30);
        Vektor v19=new Vektor(5,45,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,30);
        Vektor v22=new Vektor(45,45,30);
        Vektor v23=new Vektor(45,45,0);
        Vektor v24=new Vektor(45,5,0);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,30);
        Vektor v26=new Vektor(40,10,30);
        Vektor v27=new Vektor(40,40,30);
        Vektor v28=new Vektor(10,40,30);
        Quad q7=new Quad(Color.orange,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
    public static Group getLochz(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(45,5,0);
        Vektor v7=new Vektor(45,45,0);
        Vektor v8=new Vektor(5,45,0);
        Quad q2=new Quad(Color.black,Color.black,v5,v6,v7,v8);
        Group g=new Group();
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getBodenz(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(45,5,0);
        Vektor v7=new Vektor(45,45,0);
        Vektor v8=new Vektor(5,45,0);
        Quad q2=new Quad(Color.lightGray,Color.black,v5,v6,v7,v8);
        Group g=new Group();
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getSteinz(){
        Vektor v1=new Vektor(5,5,0);
        Vektor v2=new Vektor(45,5,0);
        Vektor v3=new Vektor(45,45,0);
        Vektor v4=new Vektor(5,45,0);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,30);
        Vektor v6=new Vektor(45,5,30);
        Vektor v7=new Vektor(45,45,30);
        Vektor v8=new Vektor(5,45,30);
        Quad q2=new Quad(Color.orange,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,30);
        Vektor v10=new Vektor(45,5,30);
        Vektor v11=new Vektor(45,5,0);
        Vektor v12=new Vektor(5,5,0);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,45,30);
        Vektor v14=new Vektor(45,45,30);
        Vektor v15=new Vektor(45,45,0);
        Vektor v16=new Vektor(5,45,0);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,5,30);
        Vektor v18=new Vektor(5,45,30);
        Vektor v19=new Vektor(5,45,0);
        Vektor v20=new Vektor(5,5,0);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,30);
        Vektor v22=new Vektor(45,45,30);
        Vektor v23=new Vektor(45,45,0);
        Vektor v24=new Vektor(45,5,0);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        Vektor v25=new Vektor(10,10,30);
        Vektor v26=new Vektor(40,10,30);
        Vektor v27=new Vektor(40,40,30);
        Vektor v28=new Vektor(10,40,30);
        Quad q7=new Quad(Color.yellow,Color.black,v25,v26,v27,v28);
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q7.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        g.add(q7);
        return g;
    }
    public static Group getZufall(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.blue,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,5);
        Vektor v6=new Vektor(45,5,5);
        Vektor v7=new Vektor(45,45,5);
        Vektor v8=new Vektor(5,45,5);
        Quad q2=new Quad(Color.red,Color.black,v5,v6,v7,v8);
        Vektor v9=new Vektor(10,10,10);
        Vektor v10=new Vektor(40,10,10);
        Vektor v11=new Vektor(40,40,10);
        Vektor v12=new Vektor(10,40,10);
        Quad q3=new Quad(Color.yellow,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(15,15,15);
        Vektor v14=new Vektor(35,15,15);
        Vektor v15=new Vektor(35,35,15);
        Vektor v16=new Vektor(15,35,15);
        Quad q4=new Quad(Color.green,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(20,20,20);
        Vektor v18=new Vektor(30,20,20);
        Vektor v19=new Vektor(30,30,20);
        Vektor v20=new Vektor(20,30,20);
        Quad q5=new Quad(Color.blue,Color.black,v17,v18,v19,v20);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        return g;
    }
    public static Group getFahne(){
        Vektor v1=new Vektor(5,5,25);
        Vektor v2=new Vektor(45,5,25);
        Vektor v3=new Vektor(45,45,25);
        Vektor v4=new Vektor(5,45,25);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,25);
        Vektor v6=new Vektor(40,10,25);
        Vektor v7=new Vektor(40,40,25);
        Vektor v8=new Vektor(10,40,25);
        Quad q2=new Quad(Color.yellow,Color.yellow,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,25);
        Vektor v12=new Vektor(5,5,25);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,25);
        Vektor v16=new Vektor(5,5,25);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,25);
        Vektor v20=new Vektor(5,45,25);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,25);
        Vektor v24=new Vektor(45,5,25);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getWahl(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(40,0,0);
        Vektor v3=new Vektor(40,40,0);
        Vektor v4=new Vektor(0,40,0);
        Quad q1=new Quad(Color.green,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(5,5,0);
        Vektor v6=new Vektor(45,5,0);
        Vektor v7=new Vektor(45,45,0);
        Vektor v8=new Vektor(5,45,0);
        Quad q2=new Quad(Color.lightGray,Color.black,v5,v6,v7,v8);
        Group g=new Group();
        PaintGroup pg=new PaintGroup();
        q2.setPaintGroup(pg);
        q1.setPaintGroup(pg);
        g.add(q1);
        g.add(q2);
        return g;
    }
    public static Group getFestArrow(){
        Vektor v1=new Vektor(0,0,0);
        Vektor v2=new Vektor(50,0,0);
        Vektor v3=new Vektor(50,50,0);
        Vektor v4=new Vektor(0,50,0);
        Quad q1=new Quad(Color.green,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(20,5,0);
        Vektor v6=new Vektor(20,25,0);
        Vektor v7=new Vektor(5,25,0);
        Vektor v8=new Vektor(25,45,0);
        Vektor v9=new Vektor(45,25,0);
        Vektor v10=new Vektor(30,25,0);
        Vektor v11=new Vektor(30,5,0);
        Polygon p=new Polygon(Color.lightGray,Color.black);
        p.add(v5);
        p.add(v6);
        p.add(v7);
        p.add(v8);
        p.add(v9);
        p.add(v10);
        p.add(v11);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        p.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(p);
        return g;
    }
    public static Group getHardStone(){
        Vektor v1=new Vektor(5,5,40);
        Vektor v2=new Vektor(45,5,40);
        Vektor v3=new Vektor(45,45,40);
        Vektor v4=new Vektor(5,45,40);
        Quad q1=new Quad(Color.orange,Color.black,v1,v2,v3,v4);
        Vektor v5=new Vektor(10,10,40);
        Vektor v6=new Vektor(40,10,40);
        Vektor v7=new Vektor(40,40,40);
        Vektor v8=new Vektor(10,40,40);
        Quad q2=new Quad(Color.red,Color.red,v5,v6,v7,v8);
        Vektor v9=new Vektor(5,5,5);
        Vektor v10=new Vektor(45,5,5);
        Vektor v11=new Vektor(45,5,40);
        Vektor v12=new Vektor(5,5,40);
        Quad q3=new Quad(Color.orange,Color.black,v9,v10,v11,v12);
        Vektor v13=new Vektor(5,5,5);
        Vektor v14=new Vektor(5,45,5);
        Vektor v15=new Vektor(5,45,40);
        Vektor v16=new Vektor(5,5,40);
        Quad q4=new Quad(Color.orange,Color.black,v13,v14,v15,v16);
        Vektor v17=new Vektor(5,45,5);
        Vektor v18=new Vektor(45,45,5);
        Vektor v19=new Vektor(45,45,40);
        Vektor v20=new Vektor(5,45,40);
        Quad q5=new Quad(Color.orange,Color.black,v17,v18,v19,v20);
        Vektor v21=new Vektor(45,5,5);
        Vektor v22=new Vektor(45,45,5);
        Vektor v23=new Vektor(45,45,40);
        Vektor v24=new Vektor(45,5,40);
        Quad q6=new Quad(Color.orange,Color.black,v21,v22,v23,v24);
        PaintGroup pg=new PaintGroup();
        q1.setPaintGroup(pg);
        q2.setPaintGroup(pg);
        Group g=new Group();
        g.add(q1);
        g.add(q2);
        g.add(q3);
        g.add(q4);
        g.add(q5);
        g.add(q6);
        return g;
    }
    public static Group getKugel(){
        Vektor v1=new Vektor(25,25,25);
        Kugel kug=new Kugel(Color.blue,Color.blue,v1,20);
        Group g=new Group();
        g.add(kug);
        return g;
    }
}
class EngineXarrow3D extends JPanel{
    Thread t;
    ImageFrameXarrow3D imf;
    Image img;
    Graphics h;
    Polygon start;
    Polygon end;
    PaintGroup pgstart;
    PaintGroup pgend;
    String status="astrosolutions.de";
    boolean first=true;
    boolean ison=false;
    Graphics paintg;
    boolean inverse=false;
    private static final long serialVersionUID = -3248559261959425469L;
    public EngineXarrow3D(){
        imf=new ImageFrameXarrow3D();
        img=imf.img;
        h=img.getGraphics();
//        t=new Thread(this);
//        t.start();
    }
    public synchronized void setOn(){
        first=false;
        ison=true;
    }
    public synchronized void setOff(){
        ison=false;
    }
    public synchronized void setInverseOn(){
        inverse=true;
    }
    public synchronized void setInverseOff(){
        inverse=false;
    }
    public synchronized void run(){
        boolean running=true;
//        try{
//            while(running){
//                Thread.sleep(100);
//                repaint();
//            }
//        }
//        catch(Exception e){
//        }
    }
    public synchronized void setNotProcessed(){
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg!=null){
                cur.pg.setNotProcessed();
            }
            cur=cur.next;
        }
    }
    public synchronized void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(cur.pg!=null){
                    cur.pg.remove(cur);
                }
                if(fore==null){
                    start=cur.next;
                }
                if(cur.next==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.next=cur.next;
                }
            }
            fore=cur;
            cur=cur.next;
        }
    }
    public synchronized void remove(Group g){
        Polygon cur=g.start;
        while(cur!=null){
            remove(cur);
            cur=cur.grnext;
        }
    }
    public synchronized void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public synchronized void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public synchronized void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public synchronized void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
    public synchronized void getPaintGroups(){
        pgstart=null;
        pgend=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur.pg==null){
                cur.pg=new PaintGroup();
                cur.pg.add(cur);
                cur.pg.setProcessed();
                addPaintGroup(cur.pg);
            }
            else{
                if(!cur.pg.processed){
                    addPaintGroup(cur.pg);
                    cur.pg.setProcessed();
                }
            }
            cur=cur.next;
        }
    }
    public synchronized void addPaintGroup(PaintGroup pg){
        if(pgstart==null){
            pgstart=pg;
            pgend=pg;
        }
        else{
            pgend.next=pg;
            pgend=pgend.next;
        }
    }
    public synchronized void add(Polygon p){
        p.next=null;
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.next=p;
            end=end.next;
        }
    }
    public synchronized void add(Group group){
        Polygon cur=group.start;
        while(cur!=null){
            add(cur);
            cur=cur.grnext;
        }
    }
    public static void sort(PaintGroup[]a,int l,int r){
//Quicksort sortiert PaintGroups nach entf-Werten
        if(l>=r){
            return;
        }
        PaintGroup[]part=new PaintGroup[r-l+1];
        PaintGroup[]partm=new PaintGroup[r-l+1];
        int middle=(l+r)/2;
        double middlevalue=a[middle].entf;
        int i=0;
        int j=r-l;
        int m=0;
        for(int k=l;k<=r;k++){
            if(a[k].entf<middlevalue){
                part[i]=a[k];
                i++;
            }
            else if(a[k].entf>middlevalue){
                part[j]=a[k];
                j--;
            }
            else{
                partm[m]=a[k];
                m++;
            }
        }
        for(int k=0;k<i;k++){
            a[k+l]=part[k];
        }
        for(int k=0;k<m;k++){
            a[i+k+l]=partm[k];
        }
        for(int k=r-l;k>j;k--){
            a[k+l]=part[k];
        }
        sort(a,l,i-1+l);
        sort(a,j+1+l,r);
    }
    public synchronized Vektor getCoord(Vektor v){
        double x=v.xb;
        double y=v.yb;
        double z=v.zb;
        int w=(getSize().width)/2;
        double vx=Math.atan(y/x)/(Math.PI/6)*w;
        double vy=Math.atan(z/x)/(Math.PI/6)*w;
        double vz=x;
        Vektor rvv=new Vektor(vx,vy,vz);
        return rvv;
    }
//    public synchronized void paint(Graphics g){
//        if(first){
//            return;
//        }
//    }
    public synchronized void paint(Graphics g){
        if(first){
//            return;
        }
        if(!ison){
            if(paintg!=null){
//                paint(paintg);
//                return;
            }
        }
        h.setColor(Color.white);
        h.fillRect(0,0,800,600);
        setNotProcessed();
        getPaintGroups();
        PaintGroup pgcur=pgstart;
        int count=0;
        while(pgcur!=null){
            pgcur.getEntf();
            pgcur=pgcur.next;
            count++;
        }
        pgcur=pgstart;
        PaintGroup[]pgs=new PaintGroup[count];
        for(int i=0;i<count;i++){
            pgs[i]=pgcur;
            pgcur=pgcur.next;
        }
        sort(pgs,0,pgs.length-1);
        int width=getSize().width;
        int height=getSize().height;
        for(int i=pgs.length-1;i>=0;i--){
            Polygon pol=pgs[i].start;
            while(pol!=null){
                Vektor point=pol.start;
                if(pol.kugel){
                    Vektor kv=getCoord(point);
                    if(kv.z>0){
                        double winkel=Math.atan(pol.radius/pgs[i].entf);
                        int len=(int)((winkel/(Math.PI/6))*width/2)*2;
                        h.setColor(pol.col);
                        if(!inverse){
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2-(len/2)-((int)kv.y),len,len);
                        }
                        else{
                            h.fillOval(width/2-(len/2)+((int)kv.x),height/2+(len/2)-((int)kv.y),len,len);
                        }
                    }
                }
                else{
                    java.awt.Polygon pogy=new java.awt.Polygon();
                    boolean seen=true;
                    while(point!=null){
                        Vektor veci=getCoord(point);
                        if(veci.z<=0){
                            seen=false;
                        }
                        if(!inverse){
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2-veci.y));
                        }
                        else{
                            pogy.addPoint((int)(width/2+veci.x),(int)(height/2+veci.y));
                        }
                        point=point.next;
                    }
                    if(seen){
                        h.setColor(pol.col);
                        h.fillPolygon(pogy);
                        if(pol.col!=pol.rcol){
                            h.setColor(pol.rcol);
                            h.drawPolygon(pogy);
                        }
                    }
                }
                pol=pol.gnext;
            }
        }
        h.setColor(Color.blue);
        h.drawString(status,10,90);
        g.drawImage(img,0,0,this);
        paintg=g;
//        paint(g);
    }
    public synchronized void setStatus(String status){
        this.status=status;
    }
}
class PaintGroup{
    PaintGroup next;
    Polygon start;
    Polygon end;
    boolean processed=false;
    double entf=0;
    public PaintGroup(){
    }
    public void getEntf(){
        entf=entf();
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void reset(){
        start=null;
        end=null;
    }
    public void remove(Polygon poly){
        Polygon fore=null;
        Polygon cur=start;
        while(cur!=null){
            if(cur==poly){
                if(fore==null){
                    start=cur.gnext;
                }
                if(cur.gnext==null){
                    end=fore;
                }
                if(fore!=null){
                    fore.gnext=cur.gnext;
                }
            }
            fore=cur;
            cur=cur.gnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.gnext=p;
            end=end.gnext;
        }
    }
    public double entf(){
        int count=0;
        Polygon cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            Vektor cur2=cur.start;
            while(cur2!=null){
                sum.transform(cur2.getXb(),cur2.getYb(),cur2.getZb());
                cur2=cur2.next;
                count++;
            }
            cur=cur.gnext;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
}
class Group{
    Polygon start;
    Polygon end;
    public Group cloneo(){
        Group group=new Group();
        Polygon cur=start;
        while(cur!=null){
            group.add(cur.cloneo());
            cur=cur.grnext;
        }
        return group;
    }
    public void change(Color a,Color b){
        Polygon cur=start;
        while(cur!=null){
            cur.change(a,b);
            cur=cur.grnext;
        }
    }
    public void add(Polygon p){
        if(start==null){
            start=p;
            end=p;
        }
        else{
            end.grnext=p;
            end=end.grnext;
        }
    }
    public void move(){
        Polygon cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.grnext;
        }
    }
    public void rotUp(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.grnext;
        }
    }
    public void rotLeft(double w){
        Polygon cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.grnext;
        }
    }
    public void transform(double a,double b,double c){
        Polygon cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.grnext;
        }
    }
}
class Kugel extends Polygon{
    public Kugel(Color col,Color rcol,Vektor v,double radius){
        super(col,rcol);
        add(v);
        this.radius=radius;
        this.kugel=true;
    }
    public Vektor getCenter(){
        return start;
    }
}
class Quad extends Polygon{
    public Quad(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3,Vektor v4){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
        add(v4);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
    public Vektor getV4(){
        return start.next.next.next;
    }
}
class Triangle extends Polygon{
    public Triangle(Color col,Color rcol,Vektor v1,Vektor v2,Vektor v3){
        super(col,rcol);
        add(v1);
        add(v2);
        add(v3);
    }
    public Vektor getV1(){
        return start;
    }
    public Vektor getV2(){
        return start.next;
    }
    public Vektor getV3(){
        return start.next.next;
    }
}
class Polygon{
    Polygon next;
    Polygon gnext;
    Polygon grnext;
    PaintGroup pg;
    Vektor start;
    Vektor end;
    Color col;
    Color rcol;
    boolean kugel=false;
    double radius=0;
    boolean processed=false;
    double entf=0;
    public Polygon(Color col,Color rcol){
        this.col=col;
        this.rcol=rcol;
    }
    public void change(Color a,Color b){
        if(col.equals(a)){
            col=b;
        }
    }
    public Polygon cloneo(){
        Polygon ret=new Polygon(col,rcol);
        ret.kugel=kugel;
        ret.radius=radius;
        ret.processed=processed;
        ret.entf=entf;
        Vektor cur=start;
        while(cur!=null){
            ret.add(cur.cloneo());
            cur=cur.next;
        }
        return ret;
    }
    public void setProcessed(){
        processed=true;
    }
    public void setNotProcessed(){
        processed=false;
    }
    public void setPaintGroup(PaintGroup pg){
        this.pg=pg;
        pg.add(this);
    }
    public void add(Vektor v){
        if(start==null){
            start=v;
            end=v;
        }
        else{
            end.next=v;
            end=end.next;
        }
    }
    public void move(){
        Vektor cur=start;
        while(cur!=null){
            cur.move();
            cur=cur.next;
        }
    }
    public void rotUp(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotUp(w);
            cur=cur.next;
        }
    }
    public void rotLeft(double w){
        Vektor cur=start;
        while(cur!=null){
            cur.rotLeft(w);
            cur=cur.next;
        }
    }
    public double entf(){
        int count=0;
        Vektor cur=start;
        Vektor sum=new Vektor(0,0,0);
        while(cur!=null){
            sum.transform(cur.getX(),cur.getY(),cur.getZ());
            cur=cur.next;
            count++;
        }
        Vektor ret=new Vektor(sum.x/count,sum.y/count,sum.z/count);
        return ret.entf();
    }
    public void transform(double a,double b,double c){
        Vektor cur=start;
        while(cur!=null){
            cur.transform(a,b,c);
            cur=cur.next;
        }
    }
}
class ImageFrameXarrow3D extends JFrame{
    Image img;
    private static final long serialVersionUID = -7056513742949639722L;
    public ImageFrameXarrow3D(){
        pack();
        img=createImage(800,600);
    }
}
class Vektor{
    double x,y,z;
    double xb,yb,zb;
    double xtra;
    Vektor next;
    public Vektor(double x,double y,double z){
        this.x=x;
        this.y=y;
        this.z=z;
    }
    public void print(){
        System.out.println("x: "+x+" y: "+y+" z: "+z);
    }
    public double getX(){
        return x;
    }
    public double getY(){
        return y;
    }
    public double getZ(){
        return z;
    }
    public double getXb(){
        return xb;
    }
    public double getYb(){
        return yb;
    }
    public double getZb(){
        return zb;
    }
    public double getXtra(){
        return xtra;
    }
    public Vektor cloneo(){
        Vektor cl=new Vektor(x,y,z);
        cl.xb=xb;
        cl.yb=yb;
        cl.zb=zb;
        cl.xtra=xtra;
        return cl;
    }
    public void move(){
        xb=x;
        yb=y;
        zb=z;
    }
    public void transform(double a,double b,double c){
        x+=a;
        y+=b;
        z+=c;
    }
    public void setCoord(int coord,double a){
        if(coord==1)x=a;
        else if(coord==2)y=a;
        else if(coord==2)z=a;
    }
    public void changeCoord(int coord1,int coord2){
        double temp=0;
        if((coord1==1&&coord2==2)||(coord1==2&&coord2==1)){
            temp=x;
            x=y;
            y=temp;
        }
        if((coord1==1&&coord2==3)||(coord1==3&&coord2==1)){
            temp=x;
            x=z;
            z=temp;
        }
        if((coord1==2&&coord2==3)||(coord1==3&&coord2==1)){
            temp=y;
            y=z;
            z=temp;
        }
    }
    public double entf(){
        return Math.sqrt(x*x+y*y+z*z);
    }
    public void rotLeft(double w){
        double win=0;
        if(x==0){
            if(y>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(y/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+y*y);
        win+=w;
        x=Math.cos(win)*len;
        y=Math.sin(win)*len;
    }
    public void rotUp(double w){
        double win=0;
        if(x==0){
            if(z>0)win=Math.PI/2;
            else win=-Math.PI/2;
        }
        else{
            win=Math.atan(z/x);
        }
        if(x<0)win+=Math.PI;
        double len=Math.sqrt(x*x+z*z);
        win+=w;
        x=Math.cos(win)*len;
        z=Math.sin(win)*len;
    }
}
